//+------------------------------------------------------------------+
//|                                                      SZD Bot.mq4 |
//|                                  Copyright 2022, The Blac Group. |
//|                                                 https://blac.cc/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, The Blac Group."
#property link      "https://blac.cc/"
#property version   "1.00"
#property strict
#include <Canvas/Canvas.mqh>
#include <Arrays/List.mqh>
#include <Arrays\ArrayString.mqh>
#include <stdlib.mqh>

enum YES_NO_OPTION 
   {
      YES,
      NO
   };

enum TREND_TYPE 
   {
      BUY_TREND,
      SELL_TREND,
      NO_TREND
   };

enum TRADE_TYPE 
   {
      BUY_TRADES,
      SELL_TRADES 
   };

enum TAKEPROFIT_TYPE 
   {
      NEXT_ZONE_TP,
      CUSTOM_TP,
      NO_TP 
   };

enum STOPLOSS_TYPE 
   {
      LAST_HIGH_LOW_SL,
      CUSTOM_SL,
      NO_SL 
   };

enum STRATEGY_VERSION
   {
      STRATEGY_ONE,
      STRATEGY_TWO,
      STRATEGY_THREE
   };

const  input  string           title1              = "(Enter Your Preferred Inputs Below)";             //UNIVERSAL INPUTS SECTION:
const  input  YES_NO_OPTION    TelegramMessages    = NO;                                                //Send/Receive Telegram Messages-
const  input  string           token               = "5904656116:AAGYiv7AWD6XZqpMfaZxSl-8X8keYO0DF1c";  //Token-
const  input  long             onechatid           = 176432606;                                         //User ID-
const  input  double           FirstLot            = 0.1;                                               //First Lot Size-


const  input  string           title2              = "(Enter STRATEGY 1 Preferred Inputs Below)";       //STRATEGY 1 INPUTS SECTION:
const  input  YES_NO_OPTION    TradeStrategy_1     = YES;                                               //Trade STRATEGY 1-
const  input  ENUM_TIMEFRAMES  period_1            = PERIOD_H4;                                         //Strategy 1 Timeframe Traded-
const  input  ENUM_TIMEFRAMES  period_2            = PERIOD_D1;                                         //Strategy 1 Timeframe To Draw D/T Top & Bttm-
const  input  TAKEPROFIT_TYPE  TakeProfitOption_1  = NEXT_ZONE_TP;                                      //Strategy 1 Take-Profit Type-
const  input  int              TakeProfit_1        = 3000;                                              //Strategy 1 Take-Profit Pips-
const  input  STOPLOSS_TYPE    StopLossOption_1    = LAST_HIGH_LOW_SL;                                  //Strategy 1 Stop-Loss Type-
const  input  int              StopLoss_1          = 200;                                               //Strategy 1 Stop-Loss Pips-
const  input  int              ChangeBars          = 4;                                                 //Bars after Breakout(Change Colour)-
const  input  color            ResistanceColour    = clrOrangeRed;                                      //Resistance Zone Colour-
const  input  color            SupportColour       = clrYellowGreen;                                    //Support Zone Colour-
const  input  color            DTTopColour         = clrAqua;                                           //Double/Tripple Top Colour-
const  input  color            DTBottomColour      = clrWhite;                                          //Double/Tripple Bottom Colour-
const  input  color            UpperTrendColour    = clrYellow;                                         //Upper Trendline Colour-
const  input  color            LowerTrendColour    = clrOrange;                                         //Lower Trendline Colour-

const  input  string           title3              = "(Enter STRATEGY 2 Preferred Inputs Below)";       //STRATEGY 2 INPUTS SECTION:
const  input  YES_NO_OPTION    TradeStrategy_2     = YES;                                               //Trade STRATEGY 2-
const  input  ENUM_TIMEFRAMES  period_3            = PERIOD_H1;                                         //Strategy 2 Timeframe Traded-
const  input  ENUM_TIMEFRAMES  period_4            = PERIOD_W1;                                         //Strategy 2 Timeframe To Draw Highs & Lows-
const  input  int              TakeProfit_2        = 500;                                               //Strategy 2 Take-Profit Pips-
const  input  STOPLOSS_TYPE    StopLossOption_2    = LAST_HIGH_LOW_SL;                                  //Strategy 2 Stop-Loss Type-
const  input  int              StopLoss_2          = 200;                                               //Strategy 2 Stop-Loss Pips-
const  input  color            HighColour_2        = clrChocolate;                                      //High Zone Colour-
const  input  color            LowColour_2         = clrBlueViolet;                                     //Low Zone Colour-
const  input  int              ChangeBars_2        = 6;                                                 //Bars to Invalidate Zone(Change Colour)-
const  input  color            InvalidColour_2     = clrDarkBlue;                                       //Invalid Zone(2) Colour

const  input  string           title4              = "(Enter STRATEGY 3 Preferred Inputs Below)";       //STRATEGY 3 INPUTS SECTION:
const  input  YES_NO_OPTION    TradeStrategy_3     = YES;                                               //Trade STRATEGY 3-
const  input  ENUM_TIMEFRAMES  period_5            = PERIOD_H1;                                         //Strategy 3 Timeframe Traded-
const  input  TAKEPROFIT_TYPE  TakeProfitOption_3  = NEXT_ZONE_TP;                                      //Strategy 3 Take-Profit Type-
const  input  int              TakeProfit_3        = 500;                                               //Strategy 3 Take-Profit Pips-
const  input  STOPLOSS_TYPE    StopLossOption_3    = LAST_HIGH_LOW_SL;                                  //Strategy 3 Stop-Loss Type-
const  input  int              StopLoss_3          = 300;                                               //Strategy 3 Stop-Loss Pips-
const  input  color            HighColour_3        = clrPaleGoldenrod;                                  //Tripple Top Zone Colour-
const  input  color            LowColour_3         = clrCornsilk;                                       //Tripple Btm Zone Colour-
const  input  int              ChangeBars_3        = 6;                                                 //Bars to Invalidate Zone(Change Colour)-
const  input  color            InvalidColour_3     = clrPink;                                           //Invalid Zone(3) Colour

const  input  string           title5              = "(Enter Your Preferred Stochastic inputs Below)";  //STOCHASTIC INDICATOR INPUTS SECTION:
const  input  int              kperiod             = 21;                                                //Stochastic K Period-
const  input  int              dperiod             = 3;                                                 //Stochastic D Period-
const  input  int              slowing             = 3;                                                 //Stochastic Slowing-
const  input  ENUM_MA_METHOD   stocmethod          = MODE_SMA;                                          //Stochastic MA Method-

const  input  string           title6              = "(Enter Your Preferred Moving Avg inputs Below)";  //MOVING AVERAGE INDICATOR INPUTS SECTION:
const  input  YES_NO_OPTION    UseMA               = NO;                                                //Check Moving Average-
const  input  int              fastma              = 5;                                                 //Fast Moving Average-
const  input  int              slowma              = 13;                                                //Slow Moving Average-
const  input  ENUM_MA_METHOD   mamethod            = MODE_SMA;                                          //MA Method-

static ENUM_TIMEFRAMES         RefreshDataTime     = PERIOD_M30;
static datetime                BarTime1            = iTime(Symbol(),period_1,0);
static datetime                BarTime2            = iTime(Symbol(),period_3,0);
static datetime                BarTime3            = iTime(Symbol(),period_4,0);
static datetime                BarTime4            = iTime(Symbol(),period_5,0);
static datetime                BarTime5            = iTime(Symbol(),RefreshDataTime,0);
static TREND_TYPE              CurrentTrend        = NO_TREND;
static string                  MainComment         = "I Welcome you to SZD Bot!!";
const  string                  ClosedBelowHigh     = "Closed Below High Zone";
const  string                  ClosedAboveLow      = "Closed Above Low Zone";
const  string                  ClosedBelowTop      = "Closed Below Double Top";
const  string                  ClosedAboveBtm      = "Closed Above Double Bottom";
const  string                  ClosedBelowUp       = "Closed Below Upper Trendline";
const  string                  ClosedAboveDown     = "Closed Above Down Trendline";
const  string                  EA_Comment          = "SZD Bot";
const  string                  BullEngulfying      = "Bullish Engulfying";
const  string                  BearEngulfying      = "Bearish Engulfying";
const  string                  Nothing             = "NONE";
const  string                  Filled              = "Filled";
const  string                  Breakout            = "Breakout";
const  string                  Traded              = "Traded";
const  string                  BuyTrades           = "Buy Trades";
const  string                  SellTrades          = "Sell Trades";
const  string                  Continue            = "Continue";
const  string                  Stop                = "STOP";
const  int                     MADistance          = 50;
const  int                     MinBarSize          = 100;
const  int                     StopsBars           = 3; 
const  int                     MagicStrategy_1     = 179239;
const  int                     MagicStrategy_2     = 345190;
const  int                     MagicStrategy_3     = 354673;
const  int                     DoubleTrippleBar    = 5;
const  int                     DTDistance          = 600;
const  int                     MaxBarSize          = 300;
const  int                     HLBars              = 5; 
const  int                     HLBars_3            = 5; 
const  int                     ValidateDistance    = 50;
const  int                     ZoneDistance_2      = 100;
const  int                     ZoneDistance_3      = 100;

static bool                    ArrayFilled         = false;
static int                     TotalObjects        = 0;

static string                  HLBreakoutType      = Nothing;
static bool                    HLConfirmTime       = false;
static bool                    HLTradeSignal       = false;

const  string                  DTTopZoneName[]     = {"DT Top 1","DT Top 2","DT Top 3","DT Top 4","DT Top 5","DT Top 6","DT Top 7","DT Top 8","DT Top 9","DT Top 10"};
const  string                  DTBtmZoneName[]     = {"DT Btm 1","DT Btm 2","DT Btm 3","DT Btm 4","DT Btm 5","DT Btm 6","DT Btm 7","DT Btm 8","DT Btm 9","DT Btm 10"};
static string                  DTBreakoutType      = Nothing;
static bool                    DTConfirmTime       = false;
static bool                    DTTradeSignal       = false;

static string                  TRBreakoutType      = Nothing;
static bool                    TRConfirmTime       = false;
static bool                    TRTradeSignal       = false;

const  string                  HighNameStrategy_2  = "PREVIOUS HIGHs";
const  string                  LowNameStrategy_2   = "PREVIOUS LOWs";
static string                  HLBreakoutType_2    = Nothing;
static bool                    HLConfirmTime_2     = false;
static bool                    HLTradeSignal_2     = false;

const  string                  HighNameStrategy_3  = "TRIPPLE THREAT HIGH";
const  string                  LowNameStrategy_3   = "TRIPPLE THREAT LOW";
static string                  HLBreakoutType_3    = Nothing;
static bool                    HLConfirmTime_3     = false;
static bool                    HLTradeSignal_3     = false;

static bool                    OverBoughtStoc      = false;
static bool                    OverSoldStoc        = false;

const  int                     MaxArrayValues      = 1000;
static string                  ObjectsName[1000];
static string                  ObjectStatus[1000];
static double                  ObjectPrice1[1000];
static double                  ObjectPrice2[1000];
static bool                    ObjectAction[1000];

int                            ErrCode;
//+------------------------------------------------------------------+
int OnInit()
  {
      ArrayResize(ObjectsName,MaxArrayValues);
      ArrayResize(ObjectStatus,MaxArrayValues);
      ArrayResize(ObjectPrice1,MaxArrayValues);
      ArrayResize(ObjectPrice2,MaxArrayValues);
      ArrayResize(ObjectAction,MaxArrayValues);
      
      ArrayFill(ObjectPrice1,0,MaxArrayValues,0);
      ArrayFill(ObjectPrice2,0,MaxArrayValues,0);
      return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
      
  }

//+------------------------------------------------------------------+
void OnTick()
  {
      STRATEGYONE();
      STRATEGYTWO();
      STRATEGYTHREE();
      DATAHANDLER();
      ENDOFWEEKDELETEZONES();
  }

//+------------------------------------------------------------------+
void STRATEGYONE()
   {
      bool NewBarStrategy_1 = NEWBAR(period_1);
      if(!NewBarStrategy_1 || TradeStrategy_1 == NO)return;
      
      StochasticSignal(period_2);
      TrailStopLossPrice(MagicStrategy_1,period_2);
      DeleteDTTopBtm(period_2);
      DrawDTTopBottom(period_2);
      StrategyOneBreakoutCheck();
      StrategyOneConfirmationCheck();
   }

//+------------------------------------------------------------------+
void STRATEGYTWO()
   {
      bool NewBarStrategy_2 = NEWBAR(period_3);
      if(!NewBarStrategy_2 || TradeStrategy_2 == NO)return;
      
      StrategyTwoDrawHighLowZones(HighNameStrategy_2,LowNameStrategy_2,period_3,HighColour_2,LowColour_2);
      StrategyTwoBreakoutCheck();
      StrategyTwoConfirmationCheck();
   }

//+------------------------------------------------------------------+
void STRATEGYTHREE()
   {
      bool NewBarStrategy_3 = NEWBAR(period_5);
      if(!NewBarStrategy_3 || TradeStrategy_3 == NO)return;
      
      StrategyThreeDrawHighLowZones(HighNameStrategy_3,LowNameStrategy_3,period_5,HighColour_3,LowColour_3);
      StrategyThreeBreakoutCheck();
      StrategyThreeConfirmationCheck();
   }

//+------------------------------------------------------------------+
void DATAHANDLER()
   {
      bool NewBar = NEWBAR(RefreshDataTime);
      if(!NewBar)return;
      
      ArrayFreeUpdate();
      FillArrays();
      UpdateArrays();
      UpdateZones();
      ChangeZoneColours();
      UpdateZoneColours();
   }

//+------------------------------------------------------------------+
void ENDOFWEEKDELETEZONES()
   {
      datetime CurrentTime = TimeCurrent();
      MqlDateTime MyTime;
      TimeToStruct(CurrentTime,MyTime);
      
      int WeekDay   = MyTime.day_of_week;
      int hour      = MyTime.hour;
      int  minute   = MyTime.min;
      
      bool Friday   = (WeekDay == 5) && (hour == 23) && (minute >= 30);
      if(!Friday)return;
      
      if(ObjectFind(0,HighNameStrategy_2) >= 0 || ObjectFind(0,LowNameStrategy_2) >= 0)
         {
            ObjectDelete(0,HighNameStrategy_2);
            ObjectDelete(0,LowNameStrategy_2);
            
            Print("STRATEGY TWO Lines Deleted");
            HLConfirmTime_2      = false;
            HLBreakoutType_2     = Nothing;
            HLTradeSignal_2      = false;
         }
      
      if(ObjectFind(0,HighNameStrategy_3) >= 0 || ObjectFind(0,LowNameStrategy_3) >= 0)
         {
            if(ObjectFind(0,HighNameStrategy_3) >= 0)ObjectDelete(0,HighNameStrategy_3);
            if(ObjectFind(0,LowNameStrategy_3) >= 0)ObjectDelete(0,LowNameStrategy_3);
            
            Print("STRATEGY THREE Lines Deleted");
            HLConfirmTime_3      = false;
            HLBreakoutType_3     = Nothing;
            HLTradeSignal_3      = false;
         }
   }
//+------------------------------------------------------------------+
int ChartsObjectsTotal()
   {
      int Total = 0;
            
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string          name       = ObjectName(0,obj,0,-1);
            ENUM_OBJECT     Type       = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            ENUM_LINE_STYLE Style      = (ENUM_LINE_STYLE)ObjectGetInteger(0,name,OBJPROP_STYLE);
            bool            CountType  = Type == OBJ_RECTANGLE || Type == OBJ_TREND;
            
            if(CountType && Style == STYLE_SOLID)Total++;
         }
      return Total;
   }

//+------------------------------------------------------------------+
bool ObjectCorrect(string name, bool CheckColours, bool invalid_colours, bool CheckAllShapes)
   {
      if(ObjectFind(0,name) < 0)return false;
      
      ENUM_LINE_STYLE Style              = (ENUM_LINE_STYLE)ObjectGetInteger(0,name,OBJPROP_STYLE);
      ENUM_OBJECT     Type               = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
      color           Paint              = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
      bool            AllShapes          = (Type == OBJ_RECTANGLE) || (Type == OBJ_TREND);
      bool            Shape              = (Type == OBJ_RECTANGLE);
      bool            ColoursStrategy_1  = (Paint == ResistanceColour) || (Paint == SupportColour) || (Paint == DTTopColour) || (Paint == DTBottomColour) || (Paint == UpperTrendColour) || (Paint == LowerTrendColour);
      bool            ColoursStrategy_2  = (Paint == HighColour_2) || (Paint == LowColour_2);
      bool            ColoursStrategy_3  = (Paint == HighColour_3) || (Paint == LowColour_3);
      bool            InvalidColours     = (Paint == InvalidColour_2) || (Paint == InvalidColour_3);
      bool            ValidColours       = ColoursStrategy_1 || ColoursStrategy_2 || ColoursStrategy_3;
      bool            AllColours         = ValidColours || InvalidColours;
      
      if(!AllShapes || Style != STYLE_SOLID)return false;
      
      if(CheckColours && Style == STYLE_SOLID)
         {
            if(invalid_colours)
               {
                  if(InvalidColours)return false;
                  if(CheckAllShapes)
                     {
                        if(ValidColours && AllShapes)return true;
                     }
                  else if(!CheckAllShapes)
                     {
                        if(ValidColours && Shape)return true;
                     }
               }
            else if(!invalid_colours)
               {
                  if(CheckAllShapes && AllColours && AllShapes)return true;
                  else if(!CheckAllShapes && AllColours && Shape)return true;
               }  
         }
      else if(!CheckColours && Style == STYLE_SOLID)
         {
            if(CheckAllShapes && AllShapes)return true; 
            else if(!CheckAllShapes && Shape)return true; 
              
         }
      return false;
   }

//+------------------------------------------------------------------+
void FillArrays()
   {
      int ZonesTrendsTotal = ChartsObjectsTotal();
      if(TotalObjects == ZonesTrendsTotal)return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string          name             = ObjectName(0,obj,0,-1);
            bool            Correct          = ObjectCorrect(name,false,false,true);
            bool            NameFilled       = ObjectFilled(name);
            if(!Correct || NameFilled)continue;
            
            double          price_1          = ObjectGetDouble(0,name,OBJPROP_PRICE1);
            double          price_2          = ObjectGetDouble(0,name,OBJPROP_PRICE2);
            ENUM_OBJECT     Type             = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            
            ObjectsName[obj]                 = name;
            ObjectStatus[obj]                = Filled;
            ObjectAction[obj]                = False;
            
            if(price_1 > price_2 && price_1 > 0 && price_2 > 0 && Type == OBJ_RECTANGLE)
               {
                  ObjectPrice1[obj] = price_1;
                  ObjectPrice2[obj] = price_2;
               }
            else if(price_1 < price_2 && price_1 > 0 && price_2 > 0 && Type == OBJ_RECTANGLE)
               {
                  ObjectPrice1[obj] = price_2;
                  ObjectPrice2[obj] = price_1;
               }
            else if(price_1 < price_2 && price_1 > 0 && price_2 > 0 && Type == OBJ_TREND)
               {
                  ObjectPrice1[obj] = price_2;
                  ObjectPrice2[obj] = price_1;
               }
            else if(price_1 > price_2 && price_1 > 0 && price_2 > 0 && Type == OBJ_TREND)
               {
                  ObjectPrice1[obj] = price_1;
                  ObjectPrice2[obj] = price_2;
               }
         }
      MainComment = "DATA FILED & UPDATED";
      Print(MainComment);
      TotalObjects   = ChartsObjectsTotal();
      ArrayFilled    = true;
   }

//+------------------------------------------------------------------+
void ArrayFreeUpdate()
   {
      for(int obj = 0; obj < ArraySize(ObjectsName); obj++)
         {
            string name = ObjectsName[obj];
            
            if(ObjectFind(0,name) >= 0)continue;
            
            ObjectsName[obj]    = "";
            ObjectStatus[obj]   = Nothing;
            ObjectPrice1[obj]   = 0;
            ObjectPrice2[obj]   = 0;
            ObjectAction[obj]   = False;
            return;
         }
   }

//+------------------------------------------------------------------+
bool ObjectFilled(string name)
   {
      for(int obj = 0; obj < ArraySize(ObjectsName); obj++)
         {
            string title = ObjectsName[obj];
            if(title != name)continue;
            return true;
         }
      return false;
   }

//+------------------------------------------------------------------+
void UpdateArrays()
   {
      int ZonesTrendsTotal = ChartsObjectsTotal();
      if(TotalObjects != ZonesTrendsTotal)return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string          name             = ObjectName(0,obj,0,-1);
            bool            Correct          = ObjectCorrect(name,true,true,true);
            bool            NameFilled       = ObjectFilled(name);
            if(!Correct || !NameFilled)continue;
            
            double          price_1          = ObjectGetDouble(0,name,OBJPROP_PRICE1);
            double          price_2          = ObjectGetDouble(0,name,OBJPROP_PRICE2);
            
            for(int objs = 0; objs < ArraySize(ObjectsName); objs++)
               {
                  if(ObjectsName[objs] != name)continue;
                  
                  if(price_1 > price_2)
                     {
                        if(ObjectPrice1[objs] != price_1)ObjectPrice1[objs] = price_1;
                        if(ObjectPrice2[objs] != price_2)ObjectPrice2[objs] = price_2;
                     }
                  else if(price_1 < price_2)
                     {
                        if(ObjectPrice1[objs] != price_2)ObjectPrice1[objs] = price_2;
                        if(ObjectPrice2[objs] != price_1)ObjectPrice2[objs] = price_1;
                     }
               }
         }
   }

//+------------------------------------------------------------------+
void UpdateZones()
   {
      int ZonesTrendsTotal = ChartsObjectsTotal();
      if(TotalObjects != ZonesTrendsTotal)return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string          name             = ObjectName(0,obj,0,-1);
            bool            Correct          = ObjectCorrect(name,true,false,false);
            bool            NameFilled       = ObjectFilled(name);
            if(!Correct || !NameFilled)continue;
            
            double          price_1          = ObjectGetDouble(0,name,OBJPROP_PRICE1);
            double          price_2          = ObjectGetDouble(0,name,OBJPROP_PRICE2);
            datetime        time_1           = (datetime)ObjectGetInteger(0,name,OBJPROP_TIME1);
            datetime        time_2           = (datetime)ObjectGetInteger(0,name,OBJPROP_TIME2);
            
            if(time_1 > time_2)ObjectMove(0,name,1,Time[0],price_1);
            else if(time_1 < time_2)ObjectMove(0,name,1,Time[0],price_2);
         }
   }

//+------------------------------------------------------------------+
void ChangeZoneColours()
   {
      int ZonesTrendsTotal = ChartsObjectsTotal();
      if(TotalObjects != ZonesTrendsTotal)return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string          name               = ObjectName(0,obj,0,-1);
            bool            NameFilled         = ObjectFilled(name);
            if(!NameFilled)continue;
            
            ENUM_LINE_STYLE Style              = (ENUM_LINE_STYLE)ObjectGetInteger(0,name,OBJPROP_STYLE);
            ENUM_OBJECT     Type               = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            color           Paint              = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool            AllShapes          = (Type == OBJ_RECTANGLE) || (Type == OBJ_TREND);
            bool            ColoursStrategy_1  = (Paint == ResistanceColour) || (Paint == SupportColour) || (Paint == DTTopColour) || (Paint == DTBottomColour) || (Paint == UpperTrendColour) || (Paint == LowerTrendColour);
            bool            ColoursStrategy_2  = (Paint == HighColour_2) || (Paint == LowColour_2);
            bool            ColoursStrategy_3  = (Paint == HighColour_3) || (Paint == LowColour_3);
            bool            InvalidColours     = (Paint == InvalidColour_2) || (Paint == InvalidColour_3);
            bool            ValidColours       = ColoursStrategy_1 || ColoursStrategy_2 || ColoursStrategy_3;
            bool            AllColours         = ValidColours || InvalidColours;
            if(AllColours || !AllShapes)continue;
            
            double          price_1            = ObjectGetDouble(0,name,OBJPROP_PRICE1);
            double          price_2            = ObjectGetDouble(0,name,OBJPROP_PRICE2);
            double          price_3            = ObjectGetValueByTime(0,name,Time[0]);
            double          ask                = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double          bid                = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            
            if(bid > price_1 && bid > price_2 && Type == OBJ_RECTANGLE)ObjectSetInteger(0,name,OBJPROP_COLOR,SupportColour);
            else if(ask < price_1 && ask < price_2 && Type == OBJ_RECTANGLE)ObjectSetInteger(0,name,OBJPROP_COLOR,ResistanceColour);
            else if(bid > price_3 && bid > price_3 && Type == OBJ_TREND)ObjectSetInteger(0,name,OBJPROP_COLOR,LowerTrendColour);
            else if(ask < price_3 && ask < price_3 && Type == OBJ_TREND)ObjectSetInteger(0,name,OBJPROP_COLOR,UpperTrendColour);
            
            ObjectSetInteger(0,name,OBJPROP_FILL,true);
            ObjectSetInteger(0,name,OBJPROP_BACK,true);
         }
   }


//+------------------------------------------------------------------+
void UpdateZoneColours()
   {
      int ZonesTrendsTotal = ChartsObjectsTotal();
      if(TotalObjects != ZonesTrendsTotal)return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string          name             = ObjectName(0,obj,0,-1);
            bool            Correct          = ObjectCorrect(name,true,true,false);
            bool            NameFilled       = ObjectFilled(name);
            if(!Correct || !NameFilled)continue;
            
            double          price_1          = ObjectGetDouble(0,name,OBJPROP_PRICE1);
            double          price_2          = ObjectGetDouble(0,name,OBJPROP_PRICE2);
            double          price_3          = ObjectGetValueByTime(0,name,Time[0]);
            double          ask              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double          bid              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            color           ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool            Broken           = true;
            
            if(ObjectPaint == SupportColour)
               {
                  if(ask < price_1 && ask < price_2)
                     {
                        for(int b = 0; b <= ChangeBars; b++)
                           {
                              double BarHigh = iHigh(_Symbol,period_1,b);
                              double BarLow  = iLow(_Symbol,period_1,b);
                              
                              if(BarHigh < price_1 && BarHigh < price_2 && BarLow < price_1 && BarLow < price_2)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              HLConfirmTime      = false;
                              HLBreakoutType     = Nothing;
                              HLTradeSignal      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,ResistanceColour);
                              ObjectSetInteger(0,name,OBJPROP_FILL,true);
                              ObjectSetInteger(0,name,OBJPROP_BACK,true);
                              continue;
                           }
                     }
               }
            else if(ObjectPaint == ResistanceColour)
               {
                  if(bid > price_1 && bid > price_2)
                     {
                        for(int b = 0; b <= ChangeBars; b++)
                           {
                              double BarHigh = iHigh(_Symbol,period_1,b);
                              double BarLow  = iLow(_Symbol,period_1,b);
                              
                              if(BarHigh > price_1 && BarHigh > price_2 && BarLow > price_1 && BarLow > price_2)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              HLConfirmTime      = false;
                              HLBreakoutType     = Nothing;
                              HLTradeSignal      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,SupportColour);
                              ObjectSetInteger(0,name,OBJPROP_FILL,true);
                              ObjectSetInteger(0,name,OBJPROP_BACK,true);
                              continue;
                           }
                     }
               }       
            else if(ObjectPaint == UpperTrendColour)
               {
                  if(bid > price_3)
                     {
                        for(int b = 0; b <= ChangeBars; b++)
                           {
                              double BarHigh = iHigh(_Symbol,period_1,b);
                              double BarLow  = iLow(_Symbol,period_1,b);
                              
                              if(BarHigh > price_3 && BarLow > price_3)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              TRConfirmTime      = false;
                              TRBreakoutType     = Nothing;
                              TRTradeSignal      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,LowerTrendColour);
                              continue;
                           }
                        else if(!Broken)
                           {
                              Broken = true;
                              continue;
                           } 
                     }
               }
            else if(ObjectPaint == LowerTrendColour)
               {
                  if(ask < price_3)
                     {
                        for(int b = 0; b <= ChangeBars; b++)
                           {
                              double BarHigh = iHigh(_Symbol,period_1,b);
                              double BarLow  = iLow(_Symbol,period_1,b);
                              
                              if(BarHigh < price_3 && BarLow < price_3)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              TRConfirmTime      = false;
                              TRBreakoutType     = Nothing;
                              TRTradeSignal      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,UpperTrendColour);
                              continue;
                           }
                        else if(!Broken)
                           {
                              Broken = true;
                              continue;
                           } 
                     }
               }               
            else if(ObjectPaint == LowColour_2)
               {
                  if(ask < price_1 && ask < price_2)
                     {
                        for(int b = 0; b <= ChangeBars_2; b++)
                           {
                              double BarHigh  = iHigh(_Symbol,period_3,b);
                              double BarOpen  = iOpen(_Symbol,period_3,b);
                              double BarClose = iClose(_Symbol,period_3,b);
                              double BarLow   = iLow(_Symbol,period_3,b);
                              
                              if(BarHigh < price_1 && BarHigh < price_2 && BarOpen < price_1 && BarOpen < price_2 && BarClose < price_1 && BarClose < price_2)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              HLConfirmTime_2      = false;
                              HLBreakoutType_2     = Nothing;
                              HLTradeSignal_2      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,InvalidColour_2);
                              ObjectSetInteger(0,name,OBJPROP_FILL,true);
                              ObjectSetInteger(0,name,OBJPROP_BACK,true);
                              continue;
                           }
                     }
               }
            else if(ObjectPaint == HighColour_2)
               {
                  if(bid > price_1 && bid > price_2)
                     {
                        for(int b = 0; b <= ChangeBars_2; b++)
                           {
                              double BarHigh  = iHigh(_Symbol,period_3,b);
                              double BarOpen  = iOpen(_Symbol,period_3,b);
                              double BarClose = iClose(_Symbol,period_3,b);
                              double BarLow   = iLow(_Symbol,period_3,b);
                              
                              if(BarHigh > price_1 && BarHigh > price_2 && BarOpen > price_1 && BarOpen > price_2 && BarClose > price_1 && BarClose > price_2)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              HLConfirmTime_2      = false;
                              HLBreakoutType_2     = Nothing;
                              HLTradeSignal_2      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,InvalidColour_2);
                              ObjectSetInteger(0,name,OBJPROP_FILL,true);
                              ObjectSetInteger(0,name,OBJPROP_BACK,true);
                              continue;
                           }
                     }
               }            
            
            else if(ObjectPaint == LowColour_3)
               {
                  if(ask < price_1 && ask < price_2)
                     {
                        for(int b = 0; b <= ChangeBars_3; b++)
                           {
                              double BarHigh  = iHigh(_Symbol,period_5,b);
                              double BarOpen  = iOpen(_Symbol,period_5,b);
                              double BarClose = iClose(_Symbol,period_5,b);
                              double BarLow   = iLow(_Symbol,period_5,b);
                              
                              if(BarHigh < price_1 && BarHigh < price_2 && BarOpen < price_1 && BarOpen < price_2 && BarClose < price_1 && BarClose < price_2)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              HLConfirmTime_2      = false;
                              HLBreakoutType_2     = Nothing;
                              HLTradeSignal_2      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,InvalidColour_3);
                              ObjectSetInteger(0,name,OBJPROP_FILL,true);
                              ObjectSetInteger(0,name,OBJPROP_BACK,true);
                              continue;
                           }
                     }
               }
            else if(ObjectPaint == HighColour_3)
               {
                  if(bid > price_1 && bid > price_2)
                     {
                        for(int b = 0; b <= ChangeBars_3; b++)
                           {
                              double BarHigh  = iHigh(_Symbol,period_5,b);
                              double BarOpen  = iOpen(_Symbol,period_5,b);
                              double BarClose = iClose(_Symbol,period_5,b);
                              double BarLow   = iLow(_Symbol,period_5,b);
                              
                              if(BarHigh > price_1 && BarHigh > price_2 && BarOpen > price_1 && BarOpen > price_2 && BarClose > price_1 && BarClose > price_2)continue;
                              else
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(Broken)
                           {
                              HLConfirmTime_2      = false;
                              HLBreakoutType_2     = Nothing;
                              HLTradeSignal_2      = false;
                              ObjectSetInteger(0,name,OBJPROP_COLOR,InvalidColour_3);
                              ObjectSetInteger(0,name,OBJPROP_FILL,true);
                              ObjectSetInteger(0,name,OBJPROP_BACK,true);
                              continue;
                           }
                     }
               }            
         }
   }

//+-----------------------------------------------------------+
string EngulfyingType(ENUM_TIMEFRAMES period)
   {
      double close1    = NormalizeDouble(iClose(_Symbol,period,1),_Digits);
      double open1     = NormalizeDouble(iOpen(_Symbol,period,1),_Digits);
      double high1     = NormalizeDouble(iHigh(_Symbol,period,1),_Digits);
      double low1      = NormalizeDouble(iLow(_Symbol,period,1),_Digits);
      
      double close2    = NormalizeDouble(iClose(_Symbol,period,2),_Digits);
      double open2     = NormalizeDouble(iOpen(_Symbol,period,2),_Digits);
      double high2     = NormalizeDouble(iHigh(_Symbol,period,2),_Digits);
      double low2      = NormalizeDouble(iLow(_Symbol,period,2),_Digits);
      
      double barsize   = NormalizeDouble(((high1 - low1) / _Point),0);
      if(MinBarSize > barsize)return Nothing;
      
      bool bull_candle_1 = open1 < close1;
      bool bull_candle_2 = open2 < close2;
      bool bear_candle_1 = open1 > close1;
      bool bear_candle_2 = open2 > close2;
      bool bullish_1     = close1 - open1 > (2 * (open2 - close2));
      bool bearish_1     = open1 - close1 > (2 * (close2 - open2));
      bool bullish_2     = bull_candle_1 && bull_candle_2 && (close1 - open1 > close2 - open2);
      bool bearish_2     = bear_candle_1 && bear_candle_2 && (open1 - close1 > open2 - close2);
      
      if(low1 < low2 && high1 > high2 && close1 > open2 && bull_candle_1 && bear_candle_2)return BullEngulfying;
      else if(low1 < low2 && high1 > high2 && close1 < open2 && bear_candle_1 && bull_candle_2)return BearEngulfying;
      else if(bullish_1 && bull_candle_1 && bear_candle_2)return BullEngulfying;
      else if(bearish_1 && bear_candle_1 && bull_candle_2)return BearEngulfying;
      else if(bullish_2)return BullEngulfying;
      else if(bearish_2)return BearEngulfying;
      
      return Nothing;
   }

//+------------------------------------------------------------------+
bool MovingAverageSignal(TREND_TYPE TrendType,ENUM_TIMEFRAMES period)
   {
      double currentfast   = iMA(_Symbol,period,fastma,0,mamethod,PRICE_CLOSE,1);
      double currentslow   = iMA(_Symbol,period,slowma,0,mamethod,PRICE_CLOSE,1);
      double close         = NormalizeDouble(iClose(_Symbol,period,1),_Digits);
      
      if(TrendType == BUY_TREND)
         {
            if(currentfast > currentslow + MADistance * _Point && close > currentslow)return true;
         }
      else if(TrendType == SELL_TREND)
         {
            if(currentfast + MADistance * _Point < currentslow && close < currentslow)return true;
         }
      
      return false;
   }

//+------------------------------------------------------------------+
void StochasticSignal(ENUM_TIMEFRAMES period)
   {
      double currentmainline     = iStochastic(_Symbol,period,kperiod,dperiod,slowing,stocmethod,0,MODE_MAIN,1);
      double previousmainline    = iStochastic(_Symbol,period,kperiod,dperiod,slowing,stocmethod,0,MODE_MAIN,2);
      double currentsignalline   = iStochastic(_Symbol,period,kperiod,dperiod,slowing,stocmethod,0,MODE_SIGNAL,1);
      double previoussignalline  = iStochastic(_Symbol,period,kperiod,dperiod,slowing,stocmethod,0,MODE_SIGNAL,2);
      int    MaxStoc             = 80;
      int    MinStoc             = 20;
      bool   OverBought          = previousmainline > MaxStoc || previoussignalline > MaxStoc;
      bool   OverSold            = previousmainline < MinStoc || previoussignalline < MinStoc;
      
      if(!OverBoughtStoc && OverBought && currentmainline < MaxStoc && currentsignalline < MaxStoc && currentmainline < currentsignalline)
         {
            OverBoughtStoc = true;
            OverSoldStoc   = false;
         }
      if(!OverSoldStoc && OverSold && currentmainline > MinStoc && currentsignalline > 2 && currentmainline > currentsignalline)
         {
            OverBoughtStoc = false;
            OverSoldStoc   = true;
         }
      if(OverBoughtStoc && !OverSoldStoc && currentmainline > MaxStoc && currentsignalline > MaxStoc && currentmainline > currentsignalline)OverBoughtStoc = false;
      if(!OverBoughtStoc && OverSoldStoc && currentmainline < MinStoc && currentsignalline < MinStoc && currentmainline < currentsignalline)OverSoldStoc   = false;
   }

//+------------------------------------------------------------------+
bool OpenBuyTrades()
   {
      for(int i = OrdersTotal() - 1; i >= 0; i--)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)return false;
            if(OrderSymbol() != _Symbol)continue;
            if(OrderType() != ORDER_TYPE_BUY)continue;
            
            return true;
         }
      return false;
   }

//+------------------------------------------------------------------+
bool OpenSellTrades()
   {
      for(int i = OrdersTotal() - 1; i >= 0; i--)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)return false;
            if(OrderSymbol() != _Symbol)continue;
            if(OrderType() != ORDER_TYPE_SELL)continue;
            
            return true;
         }
      return false;
   }

//+------------------------------------------------------------------+
double MostHighValue(ENUM_TIMEFRAMES period)
   {
      double   high        = 0;
      
      for(int i = 1; i < 120; i++)
         {
            double CurrentHigh   = iHigh(_Symbol,period,i);
            if(CurrentHigh < high)continue;
            
            high         = CurrentHigh;
         }
      return high;
   }

//+------------------------------------------------------------------+
double MostLowValue(ENUM_TIMEFRAMES period)
   {
      double   low        = DBL_MAX;
      
      for(int i = 1; i < 240 + 2; i++)
         {
            double CurrentLow = iLow(_Symbol,period,i);
            if(CurrentLow > low)continue;
            
            low          = CurrentLow;
         }
      return low;
   }

//+------------------------------------------------------------------+
double LastHighValue(ENUM_TIMEFRAMES period)
   {
      double high = 0;
      
      for(int i = 1; i < 240; i++)
         {
            double CurrentHigh   = iHigh(_Symbol,period,i);
            if(i > StopsBars && iHighest(_Symbol,period,MODE_HIGH,StopsBars * 2 + 1,i - StopsBars) == i)
               {
                  if(CurrentHigh > high)return CurrentHigh;
               }
         }
      return 0;
   }

//+------------------------------------------------------------------+
double LastLowValue(ENUM_TIMEFRAMES period)
   {
      double low  = DBL_MAX;
      
      for(int i = 1; i < 240; i++)
         {
            double CurrentLow = iLow(_Symbol,period,i);
            if(i > StopsBars && iLowest(_Symbol,period,MODE_LOW,StopsBars * 2 + 1,i - StopsBars) == i)
               {
                  if(CurrentLow < low)return CurrentLow;
               }   
         }
      return 0;
   }

//+------------------------------------------------------------------+
double TakeProfitPrice(STRATEGY_VERSION Version, string Trade_Type)
   {
      double ask           = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
      double bid           = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
      
      if(Version == STRATEGY_ONE)
         {
            if(TakeProfitOption_1 == NO_TP)return 0;
            
            if(TakeProfitOption_1 == NEXT_ZONE_TP)
               {
                  if(Trade_Type == BuyTrades)
                     {
                        double BuyNextZoneTp = 0;
                        for(int obj = 0; obj < ArraySize(ObjectsName); obj++)
                           {
                              double price_1 = ObjectPrice1[obj];
                              double price_2 = ObjectPrice2[obj];
                              
                              if(price_1 < ask || price_2 < ask)continue;
                              
                              if(price_2 < BuyNextZoneTp || BuyNextZoneTp == 0)BuyNextZoneTp = price_2;
                           }
                        if(BuyNextZoneTp == 0)BuyNextZoneTp = ask + TakeProfit_1 * _Point;
                        return BuyNextZoneTp;
                     }
                  else if(Trade_Type == SellTrades)
                     {
                        double SellNextZoneTp = 0;
                        for(int obj = 0; obj < ArraySize(ObjectsName); obj++)
                           {
                              double price_1 = ObjectPrice1[obj];
                              double price_2 = ObjectPrice2[obj];
                              
                              if(price_1 > bid || price_2 > bid)continue;
                              
                              if(price_1 > SellNextZoneTp || SellNextZoneTp == 0)SellNextZoneTp = price_1;
                           }
                        if(SellNextZoneTp == 0)SellNextZoneTp = bid - TakeProfit_1 * _Point;
                        return SellNextZoneTp;
                     } 
               }
            else if(TakeProfitOption_1 == CUSTOM_TP)
               {
                  if(Trade_Type == BuyTrades)
                     {
                        double buycustomtp   = ask + TakeProfit_1 * _Point;
                        return buycustomtp;
                     }
                  else if(Trade_Type == SellTrades)
                     {
                        double sellcustomtp  = bid - TakeProfit_1 * _Point;
                        return sellcustomtp;
                     } 
               }
         }
      else if(Version == STRATEGY_TWO)
         {
            if(Trade_Type == BuyTrades)
               {
                  double buycustomtp_2   = ask + TakeProfit_2 * _Point;
                  return buycustomtp_2;
               }
            else if(Trade_Type == SellTrades)
               {
                  double sellcustomtp_2  = bid - TakeProfit_2 * _Point;
                  return sellcustomtp_2;
               } 
         }
      else if(Version == STRATEGY_THREE)
         {
            if(TakeProfitOption_3 == NO_TP)return 0;
            
            if(TakeProfitOption_3 == NEXT_ZONE_TP)
               {
                  if(Trade_Type == BuyTrades)
                     {
                        double BuyNextZoneTp3 = 0;
                        for(int obj = 0; obj < ArraySize(ObjectsName); obj++)
                           {
                              double price_3 = ObjectPrice1[obj];
                              double price_4 = ObjectPrice2[obj];
                              
                              if(price_3 < ask || price_4 < ask)continue;
                              
                              if(price_4 < BuyNextZoneTp3 || BuyNextZoneTp3 == 0)BuyNextZoneTp3 = price_4;
                           }
                        if(BuyNextZoneTp3 == 0)BuyNextZoneTp3 = ask + TakeProfit_3 * _Point;
                        return BuyNextZoneTp3;
                     }
                  else if(Trade_Type == SellTrades)
                     {
                        double SellNextZoneTp3 = 0;
                        for(int obj = 0; obj < ArraySize(ObjectsName); obj++)
                           {
                              double price_3 = ObjectPrice1[obj];
                              double price_4 = ObjectPrice2[obj];
                              
                              if(price_3 > bid || price_4 > bid)continue;
                              
                              if(price_3 > SellNextZoneTp3 || SellNextZoneTp3 == 0)SellNextZoneTp3 = price_3;
                           }
                        if(SellNextZoneTp3 == 0)SellNextZoneTp3 = bid - TakeProfit_3 * _Point;
                        return SellNextZoneTp3;
                     } 
               }
            else if(TakeProfitOption_3 == CUSTOM_TP)
               {
                  if(Trade_Type == BuyTrades)
                     {
                        double buycustomtp3   = ask + TakeProfit_3 * _Point;
                        return buycustomtp3;
                     }
                  else if(Trade_Type == SellTrades)
                     {
                        double sellcustomtp3  = bid - TakeProfit_3 * _Point;
                        return sellcustomtp3;
                     } 
               }
         }
      
      return 0;
   }

//+------------------------------------------------------------------+
double StopLossPrice(STRATEGY_VERSION Version, string Trade_Type, ENUM_TIMEFRAMES period)
   {
      double ask           = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
      double bid           = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
      
      if(Version == STRATEGY_ONE)
         {
            if(StopLossOption_1 == NO_SL)return 0;
            
            if(Trade_Type == BuyTrades)
               {
                  if(StopLossOption_1 == LAST_HIGH_LOW_SL)
                     {
                        double LastLowPrice = LastLowValue(period);
                        if(LastLowPrice <= 0)LastLowPrice = MostLowValue(period);
                        
                        double buylastlow   = LastLowPrice - StopLoss_1 * _Point;
                        return buylastlow;
                     }
                  else if(StopLossOption_1 == CUSTOM_SL)
                     {
                        double buycustomsl   = ask - StopLoss_1 * _Point;
                        return buycustomsl;
                     }
               }
            else if(Trade_Type == SellTrades)
               {
                  if(StopLossOption_1 == LAST_HIGH_LOW_SL)
                     {
                        double LastHighPrice = LastHighValue(period);
                        if(LastHighPrice <= 0)LastHighPrice = MostHighValue(period);
                        double selllasthigh  = LastHighPrice + StopLoss_1 * _Point;
                        return selllasthigh;
                     }
                  else if(StopLossOption_1 == CUSTOM_SL)
                     {
                        double sellcustomsl  = bid + StopLoss_1 * _Point;
                        return sellcustomsl;
                     }
               } 
         }
      else if(Version == STRATEGY_TWO)
         {
            if(StopLossOption_2 == NO_SL)return 0;
            
            if(Trade_Type == BuyTrades)
               {
                  if(StopLossOption_2 == LAST_HIGH_LOW_SL)
                     {
                        double LastLowPrice2 = LastLowValue(period);
                        if(LastLowPrice2 <= 0)LastLowPrice2 = MostLowValue(period);
                        
                        double buylastlow2   = LastLowPrice2 - StopLoss_2 * _Point;
                        return buylastlow2;
                     }
                  else if(StopLossOption_2 == CUSTOM_SL)
                     {
                        double buycustomsl2   = ask - StopLoss_2 * _Point;
                        return buycustomsl2;
                     }
               }
            else if(Trade_Type == SellTrades)
               {
                  if(StopLossOption_2 == LAST_HIGH_LOW_SL)
                     {
                        double LastHighPrice2 = LastHighValue(period);
                        if(LastHighPrice2 <= 0)LastHighPrice2 = MostHighValue(period);
                        double selllasthigh2  = LastHighPrice2 + StopLoss_2 * _Point;
                        return selllasthigh2;
                     }
                  else if(StopLossOption_2 == CUSTOM_SL)
                     {
                        double sellcustomsl2  = bid + StopLoss_2 * _Point;
                        return sellcustomsl2;
                     }
               } 
         }
      else if(Version == STRATEGY_THREE)
         {
            if(StopLossOption_3 == NO_SL)return 0;
            
            if(Trade_Type == BuyTrades)
               {
                  if(StopLossOption_3 == LAST_HIGH_LOW_SL)
                     {
                        double LastLowPrice = LastLowValue(period);
                        if(LastLowPrice <= 0)LastLowPrice = MostLowValue(period);
                        
                        double buylastlow   = LastLowPrice - StopLoss_3 * _Point;
                        return buylastlow;
                     }
                  else if(StopLossOption_3 == CUSTOM_SL)
                     {
                        double buycustomsl   = ask - StopLoss_3 * _Point;
                        return buycustomsl;
                     }
               }
            else if(Trade_Type == SellTrades)
               {
                  if(StopLossOption_3 == LAST_HIGH_LOW_SL)
                     {
                        double LastHighPrice = LastHighValue(period);
                        if(LastHighPrice <= 0)LastHighPrice = MostHighValue(period);
                        double selllasthigh  = LastHighPrice + StopLoss_3 * _Point;
                        return selllasthigh;
                     }
                  else if(StopLossOption_3 == CUSTOM_SL)
                     {
                        double sellcustomsl  = bid + StopLoss_3 * _Point;
                        return sellcustomsl;
                     }
               } 
         }
      return 0;
   }

//+------------------------------------------------------------------+
void TrailStopLossPrice(int Magic, ENUM_TIMEFRAMES period)
   {
      if(OrdersTotal() <= 0)return;
      if(StopLossOption_1 == LAST_HIGH_LOW_SL)
         {
            double LastLowPrice  = LastLowValue(period);
            double LastHighPrice = LastHighValue(period);
            
            for(int i = OrdersTotal() - 1; i >= 0; i--)
               {
                  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)break;
                  if(OrderSymbol() != _Symbol)continue;
                  if(OrderMagicNumber() != Magic)continue;
                  if(OrderType() == ORDER_TYPE_BUY)
                     {
                       if(OrderStopLoss() < LastLowPrice - StopLoss_1 * _Point)
                          {
                              bool ModifyBuy   = OrderModify(OrderTicket(),OrderOpenPrice(),LastLowPrice - StopLoss_1 * _Point,OrderTakeProfit(),0,clrNONE);
                              if(!ModifyBuy) 
                                 Print("Error in OrderModify. Error code=",GetLastError()); 
                              else 
                                 Print("Order modified successfully."); 
                          }
                     }
                  else if(OrderType() == ORDER_TYPE_SELL)
                     {
                        if(OrderStopLoss() > LastHighPrice + StopLoss_1 * _Point)
                           {
                              bool ModifySell  = OrderModify(OrderTicket(),OrderOpenPrice(),LastHighPrice + StopLoss_1 * _Point,OrderTakeProfit(),0,clrNONE);
                              if(!ModifySell) 
                                 Print("Error in OrderModify. Error code=",GetLastError()); 
                              else 
                                 Print("Order modified successfully."); 
                           }
                     }
               }
         }
   }

//+------------------------------------------------------------------+
void TBCloseOption(ENUM_TIMEFRAMES period)
   {
      if(OrdersTotal() <= 0)return;
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string name             = ObjectName(0,obj,0,-1);
            ENUM_OBJECT Type        = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            if(Type != OBJ_RECTANGLE || Type != OBJ_TREND)continue;
            
            double price_1          = ObjectGetDouble(0,name,OBJPROP_PRICE1);
            double price_2          = ObjectGetDouble(0,name,OBJPROP_PRICE2);
            double close            = NormalizeDouble(iClose(_Symbol,period,1),_Digits);
            double high             = NormalizeDouble(iHigh(_Symbol,period,1),_Digits);
            double low              = NormalizeDouble(iLow(_Symbol,period,1),_Digits);
            color  ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            color  ColourType       = clrNONE;
            
            if(CurrentTrend == BUY_TREND)
               {
                  ColourType = ResistanceColour;
                  
                  bool ColourExit = ColourType == ObjectPaint && high > price_2;
                  if(ObjectPaint != DTTopColour || !ColourExit)continue;
                  CLOSEALL(MagicStrategy_1);
                  CurrentTrend    = NO_TREND;
                  
                  for(int objs = 0; objs < ArraySize(DTTopZoneName); objs++)
                     {
                        if(ObjectFind(0,DTTopZoneName[objs]) >= 0)ObjectDelete(0,DTTopZoneName[objs]);
                        if(ObjectFind(0,DTBtmZoneName[objs]) >= 0)ObjectDelete(0,DTBtmZoneName[objs]);
                        ArrayFreeUpdate();
                     }
               }
            else if(CurrentTrend == SELL_TREND)
               {
                  ColourType = SupportColour;
                  
                  bool ColourExit = ColourType == ObjectPaint && low < price_1;
                  if(ObjectPaint != DTBottomColour || !ColourExit)continue;
                  CLOSEALL(MagicStrategy_1);
                  CurrentTrend    = NO_TREND;
                  
                  for(int objt = 0; objt < ArraySize(DTTopZoneName); objt++)
                     {
                        if(ObjectFind(0,DTTopZoneName[objt]) >= 0)ObjectDelete(0,DTTopZoneName[objt]);
                        if(ObjectFind(0,DTBtmZoneName[objt]) >= 0)ObjectDelete(0,DTBtmZoneName[objt]);
                        ArrayFreeUpdate();
                     }
               }
         }
   }
   
//+------------------------------------------------------------------+
void StrategyOneBreakoutCheck()
   {
      int ZonesTrendsTotal = ChartsObjectsTotal();
      if(TotalObjects != ZonesTrendsTotal)return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string name                        = ObjectsName[obj];
            bool        Action                 = ObjectAction[obj];
            ENUM_LINE_STYLE Style              = (ENUM_LINE_STYLE)ObjectGetInteger(0,name,OBJPROP_STYLE);
            ENUM_OBJECT     Type               = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            color           Paint              = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool            AllShapes          = (Type == OBJ_RECTANGLE) || (Type == OBJ_TREND);
            bool            Shape              = (Type == OBJ_RECTANGLE);
            bool            ColoursStrategy_1  = (Paint == ResistanceColour) || (Paint == SupportColour) || (Paint == DTTopColour) || (Paint == DTBottomColour) || (Paint == UpperTrendColour) || (Paint == LowerTrendColour);
            bool            ColoursStrategy_2  = (Paint == HighColour_2) || (Paint == LowColour_2);
            bool            ColoursStrategy_3  = (Paint == HighColour_3) || (Paint == LowColour_3);
            bool            InvalidColours     = (Paint == InvalidColour_2) || (Paint == InvalidColour_3);
            bool            ValidColours       = ColoursStrategy_2 || ColoursStrategy_3;
            bool            AllColours         = ValidColours || InvalidColours;
            
            if(!AllShapes || AllColours)continue;
            
            string          EngulfyingBar      = EngulfyingType(period_1);
            double          price_1            = ObjectPrice1[obj];
            double          price_2            = ObjectPrice2[obj];
            double          price_3            = ObjectGetValueByTime(0,name,Time[0]);
            string          Status             = ObjectStatus[obj];
            double          ask                = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double          bid                = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            double          close              = NormalizeDouble(iClose(_Symbol,period_1,1),_Digits);
            double          high               = NormalizeDouble(iHigh(_Symbol,period_1,1),_Digits);
            double          low                = NormalizeDouble(iLow(_Symbol,period_1,1),_Digits);
            bool            BuyTrend           = CurrentTrend == BUY_TREND || CurrentTrend == NO_TREND;
            bool            SellTrend          = CurrentTrend == SELL_TREND || CurrentTrend == NO_TREND; 
            
            if(Paint == ResistanceColour)
               {
                  if(!HLTradeSignal && SellTrend)
                     {
                        if(high > price_2 && close < price_2)
                           {
                              HLConfirmTime      = true;
                              HLBreakoutType     = ClosedBelowHigh;
                              HLTradeSignal      = true;
                              ObjectStatus[obj]  = Breakout;
                              ObjectAction[obj]  = true;
                              return;
                           }
                     }
               }
            else if(Paint == SupportColour)
               {
                  if(!HLTradeSignal && BuyTrend)
                     {
                        if(low < price_1 && close > price_1)
                           {
                              HLConfirmTime      = true;
                              HLBreakoutType     = ClosedAboveLow;
                              HLTradeSignal      = true;
                              ObjectStatus[obj]  = Breakout;
                              ObjectAction[obj]  = true;
                              return;
                           }
                     }
               }
            else if(Paint == DTTopColour && CurrentTrend == SELL_TREND)
               {
                  if(high > price_2 && close < price_2 && ObjectStatus[obj] == Traded)
                     {
                        if(UseMA == YES)
                           {
                              DTBreakoutType     = ClosedBelowTop;
                              DTConfirmTime      = true;
                              ObjectAction[obj]  = true;
                              return;
                           }
                        else if(UseMA == NO)
                           {
                              SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"DT Top Retest");
                              return;
                           }
                     }
                  else if(ObjectStatus[obj] == Filled && OverBoughtStoc)
                     {
                        ObjectStatus[obj] = Traded;
                        OverBoughtStoc    = false;
                        SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"DT Top Overbought");
                        return;
                     }
               }
            else if(Paint == DTBottomColour && CurrentTrend == BUY_TREND)
               {
                  if(low < price_1 && close > price_1 && Status == Traded)
                     {
                        if(UseMA == YES)
                           {
                              DTBreakoutType     = ClosedAboveBtm;
                              DTConfirmTime      = true;
                              ObjectAction[obj]  = true;
                              return;
                           }
                        else if(UseMA == NO)
                           {
                              BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"DT Btm Retest");
                              return;
                           }
                     }
                  else if(ObjectStatus[obj] == Filled && OverSoldStoc)
                     {
                        ObjectStatus[obj] = Traded;
                        OverSoldStoc      = false;
                        BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"DT Btm Oversold");
                        return;
                     }
               }
            else if(Paint == UpperTrendColour)
               {
                  if(high > price_3 && close < price_3)
                     {
                        TRBreakoutType     = ClosedBelowUp;
                        TRConfirmTime      = true;
                        ObjectStatus[obj]  = Breakout;
                        ObjectAction[obj]  = true;
                        return;
                     }
               }
            else if(Paint == LowerTrendColour)
               {
                  if(low < price_3 && close > price_3)
                     {
                        TRBreakoutType     = ClosedAboveDown;
                        TRConfirmTime      = true;
                        ObjectStatus[obj]  = Breakout;
                        ObjectAction[obj]  = true;
                        return;
                     }
               }
         }
   }

//+------------------------------------------------------------------+
void StrategyOneConfirmationCheck()
   {
      if(!HLConfirmTime && ! DTConfirmTime && TRConfirmTime)return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string name             = ObjectsName[obj];
            bool        Action           = ObjectAction[obj];
            ENUM_OBJECT Type             = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            bool        Shapes           = Type == OBJ_RECTANGLE || Type == OBJ_TREND || Action;
            bool        Name             = name == HighNameStrategy_2 || name == HighNameStrategy_3 || name == LowNameStrategy_2 || name == LowNameStrategy_3;
            if(!Shapes || Name)continue;
            
            
            string EngulfyingBar    = EngulfyingType(period_1);
            string Status           = ObjectStatus[obj];
            double ask              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double bid              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            double price_1          = ObjectPrice1[obj];
            double price_2          = ObjectPrice2[obj];
            double price_3          = ObjectGetValueByTime(0,name,Time[0]);
            double close            = NormalizeDouble(iClose(_Symbol,period_1,1),_Digits);
            double high             = NormalizeDouble(iHigh(_Symbol,period_1,1),_Digits);
            double low              = NormalizeDouble(iLow(_Symbol,period_1,1),_Digits);
            color  ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool        InvalidPaint     = ObjectPaint == InvalidColour_2 || ObjectPaint == InvalidColour_3;
            if(InvalidPaint)continue;
            bool   StrategyColours       = ObjectPaint == HighColour_2 || ObjectPaint == LowColour_2 || ObjectPaint == HighColour_3 || ObjectPaint == LowColour_3;
            bool   MainZonesColours = ObjectPaint == ResistanceColour || ObjectPaint == SupportColour;
            bool   DTZonesColours   = ObjectPaint == DTTopColour || ObjectPaint == DTBottomColour;
            bool   TrendColours     = ObjectPaint == UpperTrendColour || ObjectPaint == LowerTrendColour;
            bool   StrategyColours2 = ObjectPaint == HighColour_2 || ObjectPaint == LowColour_2;
            bool   BuyTrend_1       = MovingAverageSignal(BUY_TREND,period_1);
            bool   SellTrend_1      = MovingAverageSignal(SELL_TREND,period_1); 
            bool   BuyTrend_2       = MovingAverageSignal(BUY_TREND,period_2);
            bool   SellTrend_2      = MovingAverageSignal(SELL_TREND,period_2); 
            bool   AskMiddleZone    = ask < price_1 && ask > price_2;
            bool   BidMiddleZone    = bid < price_1 && bid > price_2;
            
            if(StrategyColours)continue;
            if(AskMiddleZone || BidMiddleZone)continue;
            if(MainZonesColours)
               {
                  if(!HLConfirmTime)continue;
                  
                  if(HLBreakoutType == ClosedAboveLow && ObjectStatus[obj] == Filled)
                     {
                        if(UseMA == YES)
                           {
                              if(BuyTrend_1 && EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = BUY_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Above Low");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = BUY_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Above Low");
                                 }
                           }
                     }
                  else if(HLBreakoutType == ClosedAboveLow && ObjectStatus[obj] == Traded)
                     {
                        if(UseMA == YES)
                           {
                              if(BuyTrend_1 && EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = BUY_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Above Low Retest Trade");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = BUY_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Above Low Retest Trade");
                                 }
                           }
                     }
                  else if(HLBreakoutType == ClosedBelowHigh && ObjectStatus[obj] == Filled)
                     {
                        if(UseMA == YES)
                           {
                              if(SellTrend_1 && EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = SELL_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Below High");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = SELL_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Below High");
                                 }
                           }
                     }
                  else if(HLBreakoutType == ClosedBelowHigh && ObjectStatus[obj] == Filled)
                     {
                        if(UseMA == YES)
                           {
                              if(SellTrend_1 && EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = SELL_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Below High Retest Trade");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime     = false;
                                    HLTradeSignal     = false;
                                    CurrentTrend      = SELL_TREND;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"Closed Below High Retest Trade");
                                 }
                           }
                     }
               }
            else if(DTZonesColours && Status == Traded && OrdersTotal() > 0)
               {
                  if(!DTConfirmTime)continue;
                  
                  if(DTBreakoutType == ClosedAboveBtm)
                     {
                        if(BuyTrend_2 && CurrentTrend == BUY_TREND && EngulfyingBar == BullEngulfying)
                           {
                              DTConfirmTime     = false;
                              DTTradeSignal     = false;
                              ObjectStatus[obj] = Traded;
                              ObjectAction[obj] = false;
                              BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"DT Btm");
                           }
                     }
                  else if(DTBreakoutType == ClosedBelowTop)
                     {
                        if(SellTrend_2 && CurrentTrend == SELL_TREND && EngulfyingBar == BearEngulfying)
                           {
                              DTConfirmTime     = false;
                              DTTradeSignal     = false;
                              ObjectStatus[obj] = Traded;
                              ObjectAction[obj] = false;
                              SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"DT Top");
                           }
                     }
               }
            else if(TrendColours && ObjectStatus[obj] == Breakout)
               {
                  if(!TRConfirmTime)continue;
                  
                  if(TRBreakoutType == ClosedAboveDown)
                     {
                        if(UseMA == YES)
                           {
                              if(BuyTrend_1)
                                 {
                                    TRConfirmTime     = false;
                                    TRTradeSignal     = false;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"TrendLine Down");
                                 }
                           }
                        else if(UseMA ==NO)
                           {
                              if(EngulfyingBar == BullEngulfying)
                                 {
                                    TRConfirmTime     = false;
                                    TRTradeSignal     = false;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    BUY(STRATEGY_ONE,MagicStrategy_1,period_1,"TrendLine Down");
                                 }
                           }
                              
                     }
                  else if(TRBreakoutType == ClosedBelowUp)
                     {
                        if(UseMA == YES)
                           {
                              if(SellTrend_1)
                                 {
                                    TRConfirmTime     = false;
                                    TRTradeSignal     = false;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"TrendLine Up");
                                 }
                           }
                        else if(UseMA ==NO)
                           {
                              if(EngulfyingBar == BearEngulfying)
                                 {
                                    TRConfirmTime     = false;
                                    TRTradeSignal     = false;
                                    ObjectStatus[obj] = Traded;
                                    ObjectAction[obj] = false;
                                    SELL(STRATEGY_ONE,MagicStrategy_1,period_1,"TrendLine Up");
                                 }
                           }
                     }
               }
         }
   }

//+------------------------------------------------------------------+
int FirstDoubleTop(ENUM_TIMEFRAMES period)
   {
      double highestHigh = 0;
      int    candle      = 0;
      
      for(int i = 0; i < 20; i++)
         {
            double high       = iHigh(_Symbol,period,i);
            
            if(i > DoubleTrippleBar && iHighest(_Symbol,period,MODE_HIGH,DoubleTrippleBar * 2 + 1,i - DoubleTrippleBar) == i)
               {
                  if(high > highestHigh)return i;
               }
            highestHigh = MathMax(high,highestHigh);
         }
      return -1;
   }

//+------------------------------------------------------------------+
int FirstDoubleBottom(ENUM_TIMEFRAMES period)
   {
      double lowestLow = DBL_MAX;
      for(int i = 0; i < 20; i++)
         {
            double low = iLow(_Symbol,period,i);
            
            if(i > DoubleTrippleBar && iLowest(_Symbol,period,MODE_LOW,DoubleTrippleBar * 2 + 1,i - DoubleTrippleBar) == i)
               {
                  if(low < lowestLow)return i;
               }   
            lowestLow = MathMin(low,lowestLow);
         }
      return -1;
   }

//+------------------------------------------------------------------+
int DoubleTrippleTop(int bar, int candles, ENUM_TIMEFRAMES period)
   {
      if(bar < 0)return -1;
      
      double price1      = iHigh(_Symbol,period,candles);
      double price2      = iClose(_Symbol,period,candles);
      
      for(int i = bar + DoubleTrippleBar; i < bar + DoubleTrippleBar + 10; i++)
         {
            double high       = iHigh(_Symbol,period,i);
            
            if(i > DoubleTrippleBar && iHighest(_Symbol,period,MODE_HIGH,DoubleTrippleBar * 2 + 1,i - DoubleTrippleBar) == i)
               {
                  bool   condition1 = high <= price1 + DTDistance * Point() && high >= price1 - DTDistance * Point();
                  bool   condition2 = DTTopPriceValidation(i,period);
                  bool   condition3 = condition1 && condition2;
                  if(!condition1)return -1;
                  
                  return i;
               }
         }
      return -1;
   }

//+------------------------------------------------------------------+
int DoubleTrippleBottom(int bar, int candles, ENUM_TIMEFRAMES period)
   {
      if(bar < 0)return -1;
      
      double price1     = iLow(_Symbol,period,candles);
      double price2     = iClose(_Symbol,period,candles);
      
      for(int i = bar + DoubleTrippleBar + 2; i < bar + DoubleTrippleBar + 10; i++)
         {
            double low = iLow(_Symbol,period,i);
            
            if(i > DoubleTrippleBar && iLowest(_Symbol,period,MODE_LOW,DoubleTrippleBar * 2 + 1,i - DoubleTrippleBar) == i)
               {
                  bool   condition1 = low <= price1 + DTDistance * Point() && low >= price1 - DTDistance * Point();
                  bool   condition2 = DTBottomPriceValidation(i,period);
                  bool   condition3 = condition1 && condition2;
                  if(!condition1)return -1;
                  
                  return i;
               }   
         }
      return -1;
   }

//+------------------------------------------------------------------+
bool DTTopPriceValidation(int bar, ENUM_TIMEFRAMES period)
   {
      double value       = iHigh(_Symbol,period,bar);
      double price1      = iClose(_Symbol,period,bar);
      double price2      = iOpen(_Symbol,period,bar);
      double price       = price1;
      
      if(price2 > price1 && (price2 - price1 < MaxBarSize * Point()))price = price2;
      else if(price2 > price1 && (price2 - price1 > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (value - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (value - price1 > MaxBarSize * Point()))return false;
      
      for(int i = 1; i < bar + DoubleTrippleBar; i++)
         {
            if(i == bar)continue;
            double high  = iHigh(_Symbol,period,i);
            double open  = iOpen(_Symbol,period,i);
            double close = iClose(_Symbol,period,i);
            double low   = iLow(_Symbol,period,i);
            
            if(low > price)return false;
            if(open > price && close > price)return false;
         }
      return true;
   }

//+------------------------------------------------------------------+
bool DTBottomPriceValidation(int bar, ENUM_TIMEFRAMES period)
   {
      double value       = iLow(_Symbol,period,bar);
      double price1      = iClose(_Symbol,period,bar);
      double price2      = iOpen(_Symbol,period,bar);
      double price       = price1;
      
      if(price2 < price1 && (price1 - price2 <= MaxBarSize * Point()))price = price2;
      else if(price2 < price1 && (price1 - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (price2 - value > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (price1 - value > MaxBarSize * Point()))return false;
      
      for(int i = 1; i < bar + DoubleTrippleBar; i++)
         {
            if(i == bar)continue;
            double high  = iHigh(_Symbol,period,i);
            double open  = iOpen(_Symbol,period,i);
            double close = iClose(_Symbol,period,i);
            double low   = iLow(_Symbol,period,i);
            
            if(high < price)return false;
            if(open < price && close < price)return false;
         }
      return true;
   }

//+------------------------------------------------------------------+
string DTTopBottomName(bool First, bool Second)
   {
      if(First)
         {
            for(int obj = 0; obj < ArraySize(DTTopZoneName); obj++)
               {
                  string name_1      = DTTopZoneName[obj];
                  if(ObjectFind(0,name_1) >= 0)continue;
                  return name_1;
               }
         }
      else if(Second)
         {
            for(int obj = 0; obj < ArraySize(DTBtmZoneName); obj++)
               {
                  string name_2      = DTBtmZoneName[obj];
                  if(ObjectFind(0,name_2) >= 0)continue;
                  return name_2;
               }
         }
            
      return "";
   }

//+------------------------------------------------------------------+
bool DTTopBottomDrawn(bool First, bool Second, double price_one, double price_two, datetime date)
   {
      if(First)
         {
            for(int obj = 0; obj < ArraySize(DTTopZoneName); obj++)
               {
                  string name_1      = DTTopZoneName[obj];
                  if(ObjectFind(0,name_1) < 0)continue;
                  double   price_1 = ObjectGetDouble(0,name_1,OBJPROP_PRICE1);
                  double   price_2 = ObjectGetDouble(0,name_1,OBJPROP_PRICE2);
                  datetime time_1  = (datetime)ObjectGetInteger(0,name_1,OBJPROP_TIME2);
                  
                  if(time_1 == date || price_1 == price_one || price_2 == price_two)return false;
               }
         }
      else if(Second)
         {
            for(int obj = 0; obj < ArraySize(DTBtmZoneName); obj++)
               {
                  string name_2      = DTBtmZoneName[obj];
                  if(ObjectFind(0,name_2) < 0)continue;
                  double   price_3 = ObjectGetDouble(0,name_2,OBJPROP_PRICE1);
                  double   price_4 = ObjectGetDouble(0,name_2,OBJPROP_PRICE2);
                  datetime time_2  = (datetime)ObjectGetInteger(0,name_2,OBJPROP_TIME2);
                  
                  if(time_2 == date || price_3 == price_one || price_4 == price_two)return false;
               }
         }
            
      return true;
   }

//+-----------------------------------------------------------+
void DrawDTTopBottom(ENUM_TIMEFRAMES period)
   {
      string DTZoneName    = DTTopBottomName(true,false);
      string DBZoneName    = DTTopBottomName(false,true);
      
      int      HighOne     = FirstDoubleTop(period);
      int      HighTwo     = DoubleTrippleTop(HighOne,HighOne,period);
      int      HighThree   = DoubleTrippleTop(HighTwo,HighOne,period);
      int      HighFour    = DoubleTrippleTop(HighThree,HighOne,period);
      datetime HZTime      = iTime(_Symbol,period,HighOne);
      double   HZPrice1    = iClose(_Symbol,period,HighOne);
      double   HZPrice2    = iHigh(_Symbol,period,HighOne);
      if(HighOne > 0 && iOpen(_Symbol,period,HighOne) > iClose(_Symbol,period,HighOne))HZPrice1 = iOpen(_Symbol,period,HighOne);
      
      int      LowOne      = FirstDoubleBottom(period);
      int      LowTwo      = DoubleTrippleBottom(LowOne,LowOne,period);
      int      LowThree    = DoubleTrippleBottom(LowTwo,LowOne,period);
      int      LowFour     = DoubleTrippleBottom(LowThree,LowOne,period);
      datetime LZTime      = iTime(_Symbol,period,LowOne);
      double   LZPrice1    = iClose(_Symbol,period,LowOne);
      double   LZPrice2    = iLow(_Symbol,period,LowOne);
      if(LowOne > 0 && iOpen(_Symbol,period,LowOne) < iClose(_Symbol,period,LowOne))LZPrice1 = iOpen(_Symbol,period,LowOne);
      
      string          currenttime  = TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES);
      string          periodstring = PeriodString(period);
      string          Message      = periodstring + "Double Top & Bottoms DRAWN at " + currenttime + " Details Below:" + " \n";
      
      if(HighOne > 0 && HighTwo > 0 && CurrentTrend == SELL_TREND)
         {
            double HighPrice1   = iHigh(_Symbol,period,HighTwo);
            double LastPrice1   = iClose(_Symbol,period,HighTwo);
            if(iOpen(_Symbol,period,HighTwo) > iClose(_Symbol,period,HighTwo))LastPrice1 = iOpen(_Symbol,period,HighTwo);
            
            if(LastPrice1 < HZPrice1)HZPrice1 = LastPrice1;
            if(HighPrice1 > HZPrice2)HZPrice2 = HighPrice1;
            HZTime      = iTime(_Symbol,period,HighTwo);
            
            if(HighThree > 0)
               {
                  double HighPrice2   = iHigh(_Symbol,period,HighThree);
                  double LastPrice2   = iClose(_Symbol,period,HighThree);
                  if(iOpen(_Symbol,period,HighThree) > iClose(_Symbol,period,HighThree))LastPrice2 = iOpen(_Symbol,period,HighThree);
                  
                  if(LastPrice2 < HZPrice1)HZPrice1 = LastPrice2;
                  if(HighPrice2 > HZPrice2)HZPrice2 = HighPrice2;
                  HZTime      = iTime(_Symbol,period,HighThree);
                  
                  if(HighFour > 0)
                     {
                        double HighPrice3   = iHigh(_Symbol,period,HighFour);
                        double LastPrice3   = iClose(_Symbol,period,HighFour);
                        if(iOpen(_Symbol,period,HighFour) > iClose(_Symbol,period,HighFour))LastPrice3 = iOpen(_Symbol,period,HighFour);
                        
                        if(LastPrice3 < HZPrice1)HZPrice1 = LastPrice3;
                        if(HighPrice3 > HZPrice2)HZPrice2 = HighPrice3;
                        HZTime      = iTime(_Symbol,period,HighFour);
                     }
               }
            bool DrawnTop = DTTopBottomDrawn(true,false,HZPrice1,HZPrice2,HZTime);
            if(!DrawnTop)return;
            
            if(ObjectCreate(DTZoneName,OBJ_RECTANGLE,0,HZTime,HZPrice1,Time[0],HZPrice2) && CurrentTrend == SELL_TREND)
               {
                  ObjectSetInteger(0,DTZoneName,OBJPROP_COLOR,DTTopColour);
                  ObjectSetInteger(0,DTZoneName,OBJPROP_STYLE,STYLE_SOLID);
                  ObjectSetInteger(0,DTZoneName,OBJPROP_SELECTABLE,true);
                  ObjectSetInteger(0,DTZoneName,OBJPROP_FILL,true); 
                  ObjectSetInteger(0,DTZoneName,OBJPROP_BACK,false); 
                  
                  string HighestTime1 = TimeToString(iTime(_Symbol,period,HighOne),TIME_DATE|TIME_MINUTES);
                  string HighestTime2 = TimeToString(iTime(_Symbol,period,HighTwo),TIME_DATE|TIME_MINUTES);
                  
                  Message  += "Double Top- TIME_ONE: " + HighestTime1 + " // TIME_TWO: " + HighestTime2 + " \n";
                  
                  Print(Message);
                  
                  return;
               }
            else if(!ObjectCreate(DTZoneName,OBJ_RECTANGLE,0,HZTime,HZPrice1,Time[0],HZPrice2) && CurrentTrend == SELL_TREND)
               {
                  string errorcomment    = "UNABLE TO Double Top on " + _Symbol;
                  Print(errorcomment);
                  return;
               }      
         }
      
      if(LowOne > 0 && LowTwo > 0 && CurrentTrend == BUY_TREND)
         {
            double LowPrice1    = iLow(_Symbol,period,LowTwo);
            double LLastPrice1   = iClose(_Symbol,period,LowTwo);
            if(iOpen(_Symbol,period,LowTwo) < iClose(_Symbol,period,LowTwo))LLastPrice1 = iOpen(_Symbol,period,LowTwo);
            
            if(LLastPrice1 > LZPrice1)LZPrice1 = LLastPrice1;
            if(LowPrice1 < LZPrice2)LZPrice2 = LowPrice1;
            LZTime      = iTime(_Symbol,period,LowTwo);
            
            if(LowThree > 0)
               {
                  double LowPrice2    = iLow(_Symbol,period,LowThree);
                  double LLastPrice2   = iClose(_Symbol,period,LowThree);
                  if(iOpen(_Symbol,period,LowThree) < iClose(_Symbol,period,LowThree))LLastPrice2 = iOpen(_Symbol,period,LowThree);
                  
                  if(LLastPrice2 > LZPrice1)LZPrice1 = LLastPrice2;
                  if(LowPrice2 < LZPrice2)LZPrice2 = LowPrice2;
                  LZTime      = iTime(_Symbol,period,LowThree);
                  
                  if(LowFour > 0)
                     {
                        double LowPrice3    = iLow(_Symbol,period,LowFour);
                        double LLastPrice3   = iClose(_Symbol,period,LowFour);
                        if(iOpen(_Symbol,period,LowFour) < iClose(_Symbol,period,LowFour))LLastPrice3 = iOpen(_Symbol,period,LowFour);
                        
                        if(LLastPrice3 > LZPrice1)LZPrice1 = LLastPrice3;
                        if(LowPrice3 < LZPrice2)LZPrice2 = LowPrice3;
                        LZTime      = iTime(_Symbol,period,LowFour);
                     }
               }
            
            bool DrawnTop = DTTopBottomDrawn(false,true,LZPrice1,LZPrice2,LZTime);
            if(!DrawnTop)return;
            
            if(ObjectCreate(DBZoneName,OBJ_RECTANGLE,0,LZTime,LZPrice1,Time[0],LZPrice2) && CurrentTrend == BUY_TREND)
               {
                  ObjectSetInteger(0,DBZoneName,OBJPROP_COLOR,DTBottomColour);
                  ObjectSetInteger(0,DBZoneName,OBJPROP_STYLE,STYLE_SOLID);
                  ObjectSetInteger(0,DBZoneName,OBJPROP_SELECTABLE,true);
                  ObjectSetInteger(0,DBZoneName,OBJPROP_FILL,true); 
                  ObjectSetInteger(0,DBZoneName,OBJPROP_BACK,false); 
                  
                  string LowestTime1 = TimeToString(iTime(_Symbol,period,LowOne),TIME_DATE|TIME_MINUTES);
                  string LowestTime2 = TimeToString(iTime(_Symbol,period,LowTwo),TIME_DATE|TIME_MINUTES);
                  
                  Message  += "Double Bottom- TIME_ONE: " + LowestTime1 + " // TIME_TWO: " + LowestTime2 + " \n";
                  Print(Message);
                  
                  return;
               }
            else if(!ObjectCreate(DBZoneName,OBJ_RECTANGLE,0,LZTime,LZPrice1,Time[0],LZPrice2) && CurrentTrend == BUY_TREND)
               {
                  string errorcomment3    = "UNABLE TO Double Bottom on " + _Symbol;
                  Print(errorcomment3);
                  return;
               }   
         }
      return;
   }

//+------------------------------------------------------------------+
void DeleteDTTopBtm(ENUM_TIMEFRAMES period)
   {    
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string      name             = ObjectName(0,obj,0,-1);
            color       ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool        DTZonesColours   = ObjectPaint == DTTopColour || ObjectPaint == DTBottomColour;
            
            if(!DTZonesColours)continue;
            
            double      price_1          = ObjectGetDouble(0,name,OBJPROP_PRICE1);
            double      price_2          = ObjectGetDouble(0,name,OBJPROP_PRICE2);
            double      ask              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double      bid              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            bool        Broken           = true;
            ENUM_OBJECT Type             = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            
            if(ObjectPaint == DTTopColour)
               {
                  if(bid > price_1 && bid > price_2)
                     {
                        for(int b = 0; b <= ChangeBars; b++)
                           {
                              double BarHigh = iHigh(_Symbol,period,b);
                              double BarLow  = iLow(_Symbol,period,b);
                              
                              if(BarHigh > price_1 && BarHigh > price_2)
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(!Broken)
                           {
                              ObjectStatus[obj]  = Filled;
                              DTConfirmTime      = false;
                              DTBreakoutType     = Nothing;
                              DTTradeSignal      = false;
                              ObjectDelete(0,name);
                              break;
                           }
                     }
               }          
            else if(ObjectPaint == DTBottomColour)
               {
                  if(ask < price_1 && ask < price_2)
                     {
                        for(int b = 0; b <= ChangeBars; b++)
                           {
                              double BarHigh = iHigh(_Symbol,period,b);
                              double BarLow  = iLow(_Symbol,period,b);
                              
                              if(BarLow < price_1 && BarLow < price_2)
                                 {
                                    Broken = false;
                                    break;
                                 }
                           }
                        if(!Broken)
                           {
                              ObjectStatus[obj]  = Filled;
                              DTConfirmTime      = false;
                              DTBreakoutType     = Nothing;
                              DTTradeSignal      = false;
                              ObjectDelete(0,name);
                              break;
                           }
                     }
               }                   
         }
   }

//+------------------------------------------------------------------+
int StrategyTwoMostHigh(ENUM_TIMEFRAMES period)
   {
      datetime PreviousWeek   = iTime(_Symbol,PERIOD_W1,1);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > PreviousWeek && BarTime < CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      double high             = 0;
      int    bar              = 0;
      int    Start            = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start; i < Range; i++)
         {
            double CurrentHigh   = iHigh(_Symbol,period,i);
            if(CurrentHigh < high)continue;
            
            high         = CurrentHigh;
            bar          = i;
         }
      return bar;
   }

//+------------------------------------------------------------------+
int StrategyTwoMostLow(ENUM_TIMEFRAMES period)
   {
      datetime PreviousWeek   = iTime(_Symbol,PERIOD_W1,1);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > PreviousWeek && BarTime < CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      double   low        = DBL_MAX;
      int      bar        = 0;
      int      Start      = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start; i < Range; i++)
         {
            double CurrentLow = iLow(_Symbol,period,i);
            if(CurrentLow > low)continue;
            
            low          = CurrentLow;
            bar          = i;
         }
      return bar;
   }

//+------------------------------------------------------------------+
int StrategyTwoLeftHighZones(int bar, int candles, ENUM_TIMEFRAMES period)
   {
      if(bar <= 0)return -1;
      
      double price1           = iHigh(_Symbol,period,candles);
      double price2           = iClose(_Symbol,period,candles);
      datetime PreviousWeek   = iTime(_Symbol,PERIOD_W1,1);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > PreviousWeek && BarTime < CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      int    Start            = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start + bar + HLBars; i < Range; i++)
         {
            double high       = iHigh(_Symbol,period,i);
            
            if(i > HLBars && iHighest(_Symbol,period,MODE_HIGH,HLBars * 2 + 1,i - HLBars) == i)
               {
      
                  bool   condition1 = high <= price1 + ZoneDistance_2 * Point() && high >= price1 - ZoneDistance_2 * Point();
                  bool   condition2 = high <= price2 + ZoneDistance_2 / 2 * Point() && high >= price2 - ZoneDistance_2 / 2 * Point();
                  bool   condition3 = condition1 || condition2;
                  bool   pricecheck = StrategyTwoRightHighPriceValidation(bar,i,period);
                  
                  if(!condition3)continue;
                  if(!pricecheck)continue;
                  return i;
               }
         }
      return -1;
   }

//+------------------------------------------------------------------+
int StrategyTwoLeftLowZones(int bar, int candles, ENUM_TIMEFRAMES period)
   {
      if(bar < 0)return -1;
      
      double price1     = iLow(_Symbol,period,candles);
      double price2     = iClose(_Symbol,period,candles);
      datetime PreviousWeek   = iTime(_Symbol,PERIOD_W1,1);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > PreviousWeek && BarTime < CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      int    Start            = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start + bar + HLBars; i < Range; i++)
         {
            double low = iLow(_Symbol,period,i);
            
            if(i > HLBars && iLowest(_Symbol,period,MODE_LOW,HLBars * 2 + 1,i - HLBars) == i)
               {
                  bool   condition1 = low <= price1 + ZoneDistance_2 * Point() && low >= price1 - ZoneDistance_2 * Point();
                  bool   condition2 = low <= price2 + ZoneDistance_2 / 2 * Point() && low >= price2 - ZoneDistance_2 / 2 * Point();
                  bool   condition3 = condition1 || condition2;
                  bool   pricecheck = StrategyTwoRightLowPriceValidation(bar,i,period);
                  
                  if(!condition3)continue;
                  if(!pricecheck)continue;
                  return i;
               }   
         }
      return -1;
   }

//+------------------------------------------------------------------+
int StrategyTwoRightHighZones(int bar, ENUM_TIMEFRAMES period)
   {
      if(bar < 0)return -1;
      
      double price1     = iHigh(_Symbol,period,bar);
      double price2     = iClose(_Symbol,period,bar);
      datetime PreviousWeek   = iTime(_Symbol,PERIOD_W1,1);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > PreviousWeek && BarTime < CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      int    Start            = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start; i < bar - HLBars; i++)
         {
            double high       = iHigh(_Symbol,period,i);
            
            if(i > HLBars && iHighest(_Symbol,period,MODE_HIGH,HLBars * 2 + 1,i - HLBars) == i)
               {
                  bool   condition1 = high <= price1 + ZoneDistance_2 * Point() && high >= price1 - ZoneDistance_2 * Point();
                  bool   condition2 = high <= price2 + ZoneDistance_2 / 2 * Point() && high >= price2 - ZoneDistance_2 / 2 * Point();
                  bool   condition3 = condition1 || condition2;
                  bool   pricecheck = StrategyTwoLeftHighPriceValidation(i,period);
                  
                  if(!condition3)continue;
                  if(!pricecheck)continue;
                  return i;
               }
         }
      return -1;
   }

//+------------------------------------------------------------------+
int StrategyTwoRightLowZones(int bar, ENUM_TIMEFRAMES period)
   {
      if(bar < 0)return -1;
      
      double price1     = iLow(_Symbol,period,bar);
      double price2     = iClose(_Symbol,period,bar);
      datetime PreviousWeek   = iTime(_Symbol,PERIOD_W1,1);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > PreviousWeek && BarTime < CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      int    Start            = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start; i < bar - HLBars; i++)
         {
            double low = iLow(_Symbol,period,i);
            
            if(i > HLBars && iLowest(_Symbol,period,MODE_LOW,HLBars * 2 + 1,i - HLBars) == i)
               {
                  bool   condition1 = low <= price1 + ZoneDistance_2 * Point() && low >= price1 - ZoneDistance_2 * Point();
                  bool   condition2 = low <= price2 + ZoneDistance_2 / 2 * Point() && low >= price2 - ZoneDistance_2 / 2 * Point();
                  bool   condition3 = condition1 || condition2;
                  bool   pricecheck = StrategyTwoLeftLowPriceValidation(i,period);
                  
                  if(!condition3)continue;
                  if(!pricecheck)continue;
                  return i;
               }   
         }
      return -1;
   }

//+------------------------------------------------------------------+
bool StrategyTwoRightHighPriceValidation(int bar, int candle, ENUM_TIMEFRAMES period)
   {
      double value       = iHigh(_Symbol,period,candle);
      double price1      = iClose(_Symbol,period,candle);
      double price2      = iOpen(_Symbol,period,candle);
      double price       = price1;
      
      if(price2 > price1 && (price2 - price1 < MaxBarSize * Point()))price = price2;
      else if(price2 > price1 && (price2 - price1 > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (value - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (value - price1 > MaxBarSize * Point()))return false;
      
      for(int i = bar + 1; i < candle; i++)
         {
            double high  = iHigh(_Symbol,period,i);
            double low   = iLow(_Symbol,period,i);
            if(low > price + ValidateDistance * _Point || low > value + ValidateDistance * _Point)return false;
            continue;
         }
      return true;
   }

//+------------------------------------------------------------------+
bool StrategyTwoRightLowPriceValidation(int bar, int candle, ENUM_TIMEFRAMES period)
   {
      double value       = iLow(_Symbol,period,candle);
      double price1      = iClose(_Symbol,period,candle);
      double price2      = iOpen(_Symbol,period,candle);
      double price       = price1;
      
      if(price2 < price1 && (price1 - price2 <= MaxBarSize * Point()))price = price2;
      else if(price2 < price1 && (price1 - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (price2 - value > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (price1 - value > MaxBarSize * Point()))return false;
      
      for(int i = bar + 1; i < candle; i++)
         {
            double high  = iHigh(_Symbol,period,i);
            if(high + ValidateDistance * _Point < price || high + ValidateDistance * _Point < value)return false;
            continue;
         }
      return true;
   }

//+------------------------------------------------------------------+
bool StrategyTwoLeftHighPriceValidation(int bar, ENUM_TIMEFRAMES period)
   {
      double value       = iHigh(_Symbol,period,bar);
      double price1      = iClose(_Symbol,period,bar);
      double price2      = iOpen(_Symbol,period,bar);
      double price       = price1;
      
      if(price2 > price1 && (price2 - price1 < MaxBarSize * Point()))price = price2;
      else if(price2 > price1 && (price2 - price1 > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (value - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (value - price1 > MaxBarSize * Point()))return false;
      
      for(int i = 1; i < bar + 10; i++)
         {
            double high = iHigh(_Symbol,period,i);
            if(high > price)continue;
            else if(high  + ValidateDistance * _Point < price)return false;
         }
      return true;
   }

//+------------------------------------------------------------------+
bool StrategyTwoLeftLowPriceValidation(int bar, ENUM_TIMEFRAMES period)
   {
      double value       = iLow(_Symbol,period,bar);
      double price1      = iClose(_Symbol,period,bar);
      double price2      = iOpen(_Symbol,period,bar);
      double price       = price1;
      
      if(price2 < price1 && (price1 - price2 <= MaxBarSize * Point()))price = price2;
      else if(price2 < price1 && (price1 - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (price2 - value > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (price1 - value > MaxBarSize * Point()))return false;
      
      for(int i = 1; i < bar + 10; i++)
         {
            double low = iLow(_Symbol,period,i);
            if(low < price)continue;
            else if(low > price + ValidateDistance * _Point)return false;
         }
      return true;
   }

//+------------------------------------------------------------------+
int StrategyTwoLastOptionHigh(int bar, ENUM_TIMEFRAMES period)
   {
      double   high        = 0;
      int      candle      = 0;
      
      for(int i = bar + 1; i < bar + 6; i++)
         {
            double high1 = iHigh(_Symbol,period,i);
            if(high1 < high)continue;
            
            high         = high1;
            candle       = i;
            continue;
         }
      if(candle > 0 && high > 0)return candle;
      
      return -1;
   }

//+------------------------------------------------------------------+
int StrategyTwoLastOptionLow(int bar, ENUM_TIMEFRAMES period)
   {
      double   low        = 0;
      int      candle     = 0;
      
      for(int i = bar + 1; i < bar + 6; i++)
         {
            double low1 = iLow(_Symbol,period,i);
            if(low1 > low && low > 0)continue;
            
            low          = low1;
            candle       = i;
            continue;
         }
      
      if(candle > 0 && low > 0)return candle;
      return -1;
   }

//+-----------------------------------------------------------+
void StrategyTwoDrawHighLowZones(string HighZoneName, string LowZoneName, ENUM_TIMEFRAMES period, color Colour, color Paint)
   {
      bool     NewBarWeek  = NEWBAR(period_4);
      if(NewBarWeek)return;
      int      HighOne     = StrategyTwoMostHigh(period);
      int      HighTwo     = StrategyTwoLeftHighZones(HighOne,HighOne,period);
      int      HighThree   = StrategyTwoLeftHighZones(HighTwo,HighOne,period);
      int      HighFour    = StrategyTwoLeftHighZones(HighThree,HighOne,period);
      int      HighFive    = StrategyTwoRightHighZones(HighOne,period);
      int      HighSix     = StrategyTwoLastOptionHigh(HighOne,period);
      datetime HZTime      = iTime(_Symbol,period,HighOne);
      double   HZPrice1    = iClose(_Symbol,period,HighOne);
      double   HZPrice2    = iHigh(_Symbol,period,HighOne);
      if(HighOne > 0 && iOpen(_Symbol,period,HighOne) > iClose(_Symbol,period,HighOne))HZPrice1 = iOpen(_Symbol,period,HighOne);
      
      int      LowOne      = StrategyTwoMostLow(period);
      int      LowTwo      = StrategyTwoLeftLowZones(LowOne,LowOne,period);
      int      LowThree    = StrategyTwoLeftLowZones(LowTwo,LowOne,period);
      int      LowFour     = StrategyTwoLeftLowZones(LowThree,LowOne,period);
      int      LowFive     = StrategyTwoRightLowZones(LowOne,period);
      int      LowSix      = StrategyTwoLastOptionLow(LowOne,period);
      datetime LZTime      = iTime(_Symbol,period,LowOne);
      double   LZPrice1    = iClose(_Symbol,period,LowOne);
      double   LZPrice2    = iLow(_Symbol,period,LowOne);
      if(LowOne > 0 && iOpen(_Symbol,period,LowOne) < iClose(_Symbol,period,LowOne))LZPrice1 = iOpen(_Symbol,period,LowOne);
      
      string          currenttime  = TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES);
      string          periodstring = PeriodString(period);
      string          Message      = periodstring + "High & Low Zones DRAWN at " + currenttime + " Details Below:" + " \n";
      
      if(HighOne > 0 && LowOne > 0 && ObjectFind(0,HighZoneName) < 0 && ObjectFind(0,LowZoneName) < 0)
         {
            if(HighTwo > 0)
               {
                  double HighPrice1   = iHigh(_Symbol,period,HighTwo);
                  double LastPrice1   = iClose(_Symbol,period,HighTwo);
                  if(iOpen(_Symbol,period,HighTwo) > iClose(_Symbol,period,HighTwo))LastPrice1 = iOpen(_Symbol,period,HighTwo);
                  
                  if(LastPrice1 < HZPrice1)HZPrice1 = LastPrice1;
                  if(HighPrice1 > HZPrice2)HZPrice2 = HighPrice1;
                  HZTime      = iTime(_Symbol,period,HighTwo);
                  
                  if(HighThree > 0)
                     {
                        double HighPrice2   = iHigh(_Symbol,period,HighThree);
                        double LastPrice2   = iClose(_Symbol,period,HighThree);
                        if(iOpen(_Symbol,period,HighThree) > iClose(_Symbol,period,HighThree))LastPrice2 = iOpen(_Symbol,period,HighThree);
                        
                        if(LastPrice2 < HZPrice1)HZPrice1 = LastPrice2;
                        if(HighPrice2 > HZPrice2)HZPrice2 = HighPrice2;
                        HZTime      = iTime(_Symbol,period,HighThree);
                        
                        if(HighFour > 0)
                           {
                              double HighPrice3   = iHigh(_Symbol,period,HighFour);
                              double LastPrice3   = iClose(_Symbol,period,HighFour);
                              if(iOpen(_Symbol,period,HighFour) > iClose(_Symbol,period,HighFour))LastPrice3 = iOpen(_Symbol,period,HighFour);
                              
                              if(LastPrice3 < HZPrice1)HZPrice1 = LastPrice3;
                              if(HighPrice3 > HZPrice2)HZPrice2 = HighPrice3;
                              HZTime      = iTime(_Symbol,period,HighFour);
                           }
                     }
               }
            if(HighFive > 0)
               {
                  double HighPrice4   = iHigh(_Symbol,period,HighFive);
                  double LastPrice4   = iClose(_Symbol,period,HighFive);
                  if(iOpen(_Symbol,period,HighFive) > iClose(_Symbol,period,HighFive))LastPrice4 = iOpen(_Symbol,period,HighFive);
                  
                  if(LastPrice4 < HZPrice1)HZPrice1 = LastPrice4;
                  if(HighPrice4 > HZPrice2)HZPrice2 = HighPrice4;
               }
            if(HighSix > 0 && HighTwo <= 0 && HighThree <= 0 && HighFour <= 0 && HighFive <= 0)
               {
                  double HighPrice5   = iHigh(_Symbol,period,HighSix);
                  double LastPrice5   = iClose(_Symbol,period,HighSix);
                  if(iOpen(_Symbol,period,HighSix) > iClose(_Symbol,period,HighSix))LastPrice5 = iOpen(_Symbol,period,HighSix);
                  
                  if(LastPrice5 < HZPrice1)HZPrice1 = LastPrice5;
                  if(HighPrice5 > HZPrice2)HZPrice2 = HighPrice5;
                  HZTime      = iTime(_Symbol,period,HighSix);
               }
            
            if(LowTwo > 0)
               {
                  double LowPrice1    = iLow(_Symbol,period,LowTwo);
                  double LLastPrice1   = iClose(_Symbol,period,LowTwo);
                  if(iOpen(_Symbol,period,LowTwo) < iClose(_Symbol,period,LowTwo))LLastPrice1 = iOpen(_Symbol,period,LowTwo);
                  
                  if(LLastPrice1 > LZPrice1)LZPrice1 = LLastPrice1;
                  if(LowPrice1 < LZPrice2)LZPrice2 = LowPrice1;
                  LZTime      = iTime(_Symbol,period,LowTwo);
                  
                  if(LowThree > 0)
                     {
                        double LowPrice2    = iLow(_Symbol,period,LowThree);
                        double LLastPrice2   = iClose(_Symbol,period,LowThree);
                        if(iOpen(_Symbol,period,LowThree) < iClose(_Symbol,period,LowThree))LLastPrice2 = iOpen(_Symbol,period,LowThree);
                        
                        if(LLastPrice2 > LZPrice1)LZPrice1 = LLastPrice2;
                        if(LowPrice2 < LZPrice2)LZPrice2 = LowPrice2;
                        LZTime      = iTime(_Symbol,period,LowThree);
                        
                        if(LowFour > 0)
                           {
                              double LowPrice3    = iLow(_Symbol,period,LowFour);
                              double LLastPrice3   = iClose(_Symbol,period,LowFour);
                              if(iOpen(_Symbol,period,LowFour) < iClose(_Symbol,period,LowFour))LLastPrice3 = iOpen(_Symbol,period,LowFour);
                              
                              if(LLastPrice3 > LZPrice1)LZPrice1 = LLastPrice3;
                              if(LowPrice3 < LZPrice2)LZPrice2 = LowPrice3;
                              LZTime      = iTime(_Symbol,period,LowFour);
                           }
                     }
               }        
            if(LowFive > 0)
               {
                  double LowPrice4    = iLow(_Symbol,period,LowFive);
                  double LLastPrice4   = iClose(_Symbol,period,LowFive);
                  if(iOpen(_Symbol,period,LowFive) < iClose(_Symbol,period,LowFive))LLastPrice4 = iOpen(_Symbol,period,LowFive);
                  
                  if(LLastPrice4 > LZPrice1)LZPrice1 = LLastPrice4;
                  if(LowPrice4 < LZPrice2)LZPrice2 = LowPrice4;
               }
            if(LowSix > 0 && LowOne > 0 && LowTwo <= 0 && LowThree <= 0 && LowFour <= 0 && LowFive <= 0)
               {
                  double LowPrice5    = iLow(_Symbol,period,LowSix);
                  double LLastPrice5   = iClose(_Symbol,period,LowSix);
                  if(iOpen(_Symbol,period,LowSix) < iClose(_Symbol,period,LowSix))LLastPrice5 = iOpen(_Symbol,period,LowSix);
                  
                  if(LLastPrice5 > LZPrice1)LZPrice1 = LLastPrice5;
                  if(LowPrice5 < LZPrice2)LZPrice2 = LowPrice5;
                  LZTime      = iTime(_Symbol,period,LowSix);
               }
            
            
            if(ObjectCreate(HighZoneName,OBJ_RECTANGLE,0,HZTime,HZPrice1,Time[0],HZPrice2))
               {
                  ObjectSetInteger(0,HighZoneName,OBJPROP_COLOR,Colour);
                  ObjectSetInteger(0,HighZoneName,OBJPROP_STYLE,STYLE_SOLID);
                  ObjectSetInteger(0,HighZoneName,OBJPROP_SELECTABLE,true);
                  ObjectSetInteger(0,HighZoneName,OBJPROP_FILL,true); 
                  ObjectSetInteger(0,HighZoneName,OBJPROP_BACK,false); 
                  
                  string HighestTime = TimeToString(iTime(_Symbol,period,HighOne),TIME_DATE|TIME_MINUTES);
                  Message  += "Highest Bar Date- " + HighestTime + " \n";
               }
            else if(!ObjectCreate(HighZoneName,OBJ_RECTANGLE,0,HZTime,HZPrice1,Time[0],HZPrice2))
               {
                  string errorcomment    = "UNABLE TO DRAW HIGH ZONE on " + _Symbol;
                  Print(errorcomment);
                  return;
               }      
            
            if(ObjectCreate(LowZoneName,OBJ_RECTANGLE,0,LZTime,LZPrice1,Time[0],LZPrice2))
               {
                  ObjectSetInteger(0,LowZoneName,OBJPROP_COLOR,Paint);
                  ObjectSetInteger(0,LowZoneName,OBJPROP_STYLE,STYLE_SOLID);
                  ObjectSetInteger(0,LowZoneName,OBJPROP_SELECTABLE,true);
                  ObjectSetInteger(0,LowZoneName,OBJPROP_FILL,true); 
                  ObjectSetInteger(0,LowZoneName,OBJPROP_BACK,false); 
                  
                  string LowestTime = TimeToString(iTime(_Symbol,period,LowOne),TIME_DATE|TIME_MINUTES);
                  Message  += "Lowest Bar Date- " + LowestTime + " \n";
               }
            else if(!ObjectCreate(LowZoneName,OBJ_RECTANGLE,0,LZTime,LZPrice1,Time[0],LZPrice2))
               {
                  string errorcomment1    = "UNABLE TO DRAW LOW ZONE on " + _Symbol;
                  Print(errorcomment1);
                  return;
               }   
            
         }
   }

//+------------------------------------------------------------------+
void StrategyTwoBreakoutCheck()
   {
      if(!ArrayFilled || TotalObjects <= 0) return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string name             = ObjectsName[obj];
            bool        Action           = ObjectAction[obj];
            ENUM_OBJECT Type             = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            bool        Shapes           = Type == OBJ_RECTANGLE || Type == OBJ_TREND || Action;
            if(!Shapes)continue;
            
            string EngulfyingBar    = EngulfyingType(period_3);
            double price_1          = ObjectPrice1[obj];
            double price_2          = ObjectPrice2[obj];
            double price_3          = ObjectGetValueByTime(0,name,Time[0]);
            string Status           = ObjectStatus[obj];
            double ask              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double bid              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            double close            = NormalizeDouble(iClose(_Symbol,period_3,1),_Digits);
            double high             = NormalizeDouble(iHigh(_Symbol,period_3,1),_Digits);
            double low              = NormalizeDouble(iLow(_Symbol,period_3,1),_Digits);
            color  ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool   StrategyColours2 = ObjectPaint == HighColour_2 || ObjectPaint == LowColour_2;
            bool   BuyTrend         = CurrentTrend == BUY_TREND || CurrentTrend == NO_TREND;
            bool   SellTrend        = CurrentTrend == SELL_TREND || CurrentTrend == NO_TREND; 
            
            if(!StrategyColours2)continue;
            
            if(StrategyColours2 && !HLTradeSignal_2 && ObjectStatus[obj] == Filled)
               {
                  if(ObjectPaint == HighColour_2 && high > price_2 && close < price_2)
                     {
                        HLConfirmTime_2      = true;
                        HLBreakoutType_2     = ClosedBelowHigh;
                        HLTradeSignal_2      = true;
                        ObjectAction[obj]    = true;
                        return;
                     }
                  else if(ObjectPaint == LowColour_2 && low < price_1 && close > price_1)
                     {
                        HLConfirmTime_2      = true;
                        HLBreakoutType_2     = ClosedAboveLow;
                        HLTradeSignal_2      = true;
                        ObjectAction[obj]    = true;
                        return;
                     }
               }
            else if(StrategyColours2 && !HLTradeSignal_2 && ObjectStatus[obj] == Traded)
               {
                  if(ObjectPaint == HighColour_2 && high > price_2 && close < price_2)
                     {
                        HLConfirmTime_2      = true;
                        HLBreakoutType_2     = ClosedBelowHigh;
                        HLTradeSignal_2      = true;
                        ObjectStatus[obj]    = Breakout;
                        ObjectAction[obj]    = true;
                        return;
                     }
                  else if(ObjectPaint == LowColour_2 && low < price_1 && close > price_1)
                     {
                        HLConfirmTime_2      = true;
                        HLBreakoutType_2     = ClosedAboveLow;
                        HLTradeSignal_2      = true;
                        ObjectStatus[obj]    = Breakout;
                        ObjectAction[obj]    = true;
                        return;
                     }
               }
         }
   }

//+------------------------------------------------------------------+
void StrategyTwoConfirmationCheck()
   {
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string name             = ObjectsName[obj];
            bool        Action           = ObjectAction[obj];
            ENUM_OBJECT Type             = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            bool        Shapes           = Type == OBJ_RECTANGLE || Type == OBJ_TREND || !Action;
            if(!Shapes)continue;
            
            string EngulfyingBar    = EngulfyingType(period_3);
            string Status           = ObjectStatus[obj];
            double ask              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double bid              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            double price_1          = ObjectPrice1[obj];
            double price_2          = ObjectPrice2[obj];
            double price_3          = ObjectGetValueByTime(0,name,Time[0]);
            double close            = NormalizeDouble(iClose(_Symbol,period_3,1),_Digits);
            double high             = NormalizeDouble(iHigh(_Symbol,period_3,1),_Digits);
            double low              = NormalizeDouble(iLow(_Symbol,period_3,1),_Digits);
            color  ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool   MainZonesColours = ObjectPaint == ResistanceColour || ObjectPaint == SupportColour;
            bool   DTZonesColours   = ObjectPaint == DTTopColour || ObjectPaint == DTBottomColour;
            bool   TrendColours     = ObjectPaint == UpperTrendColour || ObjectPaint == LowerTrendColour;
            bool   StrategyColours2 = ObjectPaint == HighColour_2 || ObjectPaint == LowColour_2;
            bool   BuyTrend_1       = MovingAverageSignal(BUY_TREND,period_3);
            bool   SellTrend_1      = MovingAverageSignal(SELL_TREND,period_3); 
            bool   BuyTrend_2       = MovingAverageSignal(BUY_TREND,period_2);
            bool   SellTrend_2      = MovingAverageSignal(SELL_TREND,period_2); 
            bool   AskMiddleZone    = ask < price_1 && ask > price_2;
            bool   BidMiddleZone    = bid < price_1 && bid > price_2;
            
            if(MainZonesColours || DTZonesColours || TrendColours || AskMiddleZone || BidMiddleZone)continue;
            
            if(StrategyColours2)
               {
                  if(!HLConfirmTime_2)continue;
                  
                  if(HLBreakoutType_2 == ClosedAboveLow && Status == Filled)
                     {
                        if(UseMA == YES)
                           {
                              if(BuyTrend_1 && EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Above Low");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Above Low");
                                 }
                           }
                     }
                  else if(HLBreakoutType_2 == ClosedAboveLow && Status == Breakout)
                     {
                        if(UseMA == YES)
                           {
                              if(BuyTrend_1 && EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Above Low Retest Trade");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Above Low Retest Trade");
                                 }
                           }
                     }
                  else if(HLBreakoutType_2 == ClosedBelowHigh && Status == Filled)
                     {
                        if(UseMA == YES)
                           {
                              if(SellTrend_1 && EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Below High");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Below High");
                                 }
                           }
                     }
                  else if(HLBreakoutType_2 == ClosedBelowHigh && Status == Breakout)
                     {
                        if(UseMA == YES)
                           {
                              if(SellTrend_1 && EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Below High Retest Trade");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_2     = false;
                                    HLTradeSignal_2     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_TWO,MagicStrategy_2,period_3,"STRATEGY 2 Closed Below High Retest Trade");
                                 }
                           }
                     }
               }
         }
   }

//+------------------------------------------------------------------+
int StrategyThreeHighZones(int bar, int candles, ENUM_TIMEFRAMES period)
   {
      if(bar <= 0)return -1;
      
      double price1           = iHigh(_Symbol,period,candles);
      double price2           = iClose(_Symbol,period,candles);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      int    Start            = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start + bar + HLBars_3; i < Range; i++)
         {
            double high       = iHigh(_Symbol,period,i);
            
            if(i > HLBars_3 && iHighest(_Symbol,period,MODE_HIGH,HLBars_3 * 2 + 1,i - HLBars_3) == i)
               {
      
                  bool   condition1 = high <= price1 + ZoneDistance_3* Point() && high >= price1 - ZoneDistance_3 * Point();
                  bool   condition2 = high <= price2 + ZoneDistance_3 / 2 * Point() && high >= price2 - ZoneDistance_3 / 2 * Point();
                  bool   condition3 = condition1 || condition2;
                  bool   pricecheck = StrategyThreeHighPriceValidation(bar,i,period);
                  
                  if(!condition3)continue;
                  return i;
               }
         }
      return -1;
   }

//+------------------------------------------------------------------+
int StrategyThreeLowZones(int bar, int candles, ENUM_TIMEFRAMES period)
   {
      if(bar < 0)return -1;
      
      double price1     = iLow(_Symbol,period,candles);
      double price2     = iClose(_Symbol,period,candles);
      datetime CurrentWeek    = iTime(_Symbol,PERIOD_W1,0);
      int      Range          = 0;
      datetime StartBar       = NULL;
      
      for(int b = 0; b < 500; b++)
         {
            datetime BarTime  = iTime(_Symbol,period,b);
            
            if(BarTime > CurrentWeek)
               {
                  Range++;
                  if(BarTime > StartBar)StartBar = BarTime;
               }
         }
      
      int    Start            = iBarShift(_Symbol,period,StartBar,true);
      
      for(int i = Start + bar + HLBars_3; i < Range; i++)
         {
            double low = iLow(_Symbol,period,i);
            
            if(i > HLBars_3 && iLowest(_Symbol,period,MODE_LOW,HLBars_3 * 2 + 1,i - HLBars_3) == i)
               {
                  bool   condition1 = low <= price1 + ZoneDistance_3 * Point() && low >= price1 - ZoneDistance_3 * Point();
                  bool   condition2 = low <= price2 + ZoneDistance_3 / 2 * Point() && low >= price2 - ZoneDistance_3 / 2 * Point();
                  bool   condition3 = condition1 || condition2;
                  bool   pricecheck = StrategyThreeLowPriceValidation(bar,i,period);
                  
                  if(!condition3)continue;
                  return i;
               }   
         }
      return -1;
   }

//+------------------------------------------------------------------+
bool StrategyThreeHighPriceValidation(int bar, int candle, ENUM_TIMEFRAMES period)
   {
      double value       = iHigh(_Symbol,period,candle);
      double price1      = iClose(_Symbol,period,candle);
      double price2      = iOpen(_Symbol,period,candle);
      double price       = price1;
      
      if(price2 > price1 && (price2 - price1 < MaxBarSize * Point()))price = price2;
      else if(price2 > price1 && (price2 - price1 > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (value - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (value - price1 > MaxBarSize * Point()))return false;
      
      for(int i = bar + 1; i < candle; i++)
         {
            double high  = iHigh(_Symbol,period,i);
            double low   = iLow(_Symbol,period,i);
            if(low > price + ValidateDistance * _Point || low > value + ValidateDistance * _Point)return false;
            continue;
         }
      return true;
   }

//+------------------------------------------------------------------+
bool StrategyThreeLowPriceValidation(int bar, int candle, ENUM_TIMEFRAMES period)
   {
      double value       = iLow(_Symbol,period,candle);
      double price1      = iClose(_Symbol,period,candle);
      double price2      = iOpen(_Symbol,period,candle);
      double price       = price1;
      
      if(price2 < price1 && (price1 - price2 <= MaxBarSize * Point()))price = price2;
      else if(price2 < price1 && (price1 - price2 > MaxBarSize * Point()))return false;
      else if(price2 < price1 && (price2 - value > MaxBarSize * Point()))return false;
      else if(price2 > price1 && (price1 - value > MaxBarSize * Point()))return false;
      
      for(int i = bar + 1; i < candle; i++)
         {
            double high  = iHigh(_Symbol,period,i);
            if(high + ValidateDistance * _Point < price || high + ValidateDistance * _Point < value)return false;
            continue;
         }
      return true;
   }

//+-----------------------------------------------------------+
void StrategyThreeDrawHighLowZones(string HighZoneName, string LowZoneName, ENUM_TIMEFRAMES period, color Colour, color Paint)
   {
      bool     NewBarWeek  = NEWBAR(period_4);
      if(NewBarWeek)return;
      int      HighOne     = StrategyThreeHighZones(0,0,period);
      int      HighTwo     = StrategyThreeHighZones(HighOne,HighOne,period);
      int      HighThree   = StrategyThreeHighZones(HighTwo,HighOne,period);
      
      datetime HZTime      = iTime(_Symbol,period,HighOne);
      double   HZPrice1    = iClose(_Symbol,period,HighOne);
      double   HZPrice2    = iHigh(_Symbol,period,HighOne);
      if(HighOne > 0 && iOpen(_Symbol,period,HighOne) > iClose(_Symbol,period,HighOne))HZPrice1 = iOpen(_Symbol,period,HighOne);
      
      int      LowOne      = StrategyThreeLowZones(0,0,period);
      int      LowTwo      = StrategyThreeLowZones(LowOne,LowOne,period);
      int      LowThree    = StrategyThreeLowZones(LowTwo,LowOne,period);
      datetime LZTime      = iTime(_Symbol,period,LowOne);
      double   LZPrice1    = iClose(_Symbol,period,LowOne);
      double   LZPrice2    = iLow(_Symbol,period,LowOne);
      if(LowOne > 0 && iOpen(_Symbol,period,LowOne) < iClose(_Symbol,period,LowOne))LZPrice1 = iOpen(_Symbol,period,LowOne);
      
      string          currenttime  = TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES);
      string          periodstring = PeriodString(period);
      string          Message      = periodstring + "High & Low Zones DRAWN at " + currenttime + " Details Below:" + " \n";
      
      if(HighOne > 0 && HighTwo > 0 && HighThree > 0 && ObjectFind(0,HighZoneName) < 0)
         {
            double HighPrice1   = iHigh(_Symbol,period,HighTwo);
            double LastPrice1   = iClose(_Symbol,period,HighTwo);
            double HighPrice2   = iHigh(_Symbol,period,HighThree);
            double LastPrice2   = iClose(_Symbol,period,HighThree);
            double HighPrice3   = HighPrice1;
            double LastPrice3   = LastPrice1;
            
            if(iOpen(_Symbol,period,HighTwo) > iClose(_Symbol,period,HighTwo))LastPrice1 = iOpen(_Symbol,period,HighTwo);
            if(iOpen(_Symbol,period,HighThree) > iClose(_Symbol,period,HighThree))LastPrice2 = iOpen(_Symbol,period,HighThree);
            
            if(HighPrice2 > HighPrice1)HighPrice3 = HighPrice2;
            if(LastPrice2 < LastPrice1)LastPrice3 = LastPrice2;
            if(HighPrice3 > HZPrice2)HZPrice2 = HighPrice3;
            if(LastPrice3 < HZPrice1)HZPrice1 = LastPrice3;
            
            HZTime      = iTime(_Symbol,period,HighThree);
            
            if(ObjectCreate(HighZoneName,OBJ_RECTANGLE,0,HZTime,HZPrice1,Time[0],HZPrice2))
               {
                  ObjectSetInteger(0,HighZoneName,OBJPROP_COLOR,Colour);
                  ObjectSetInteger(0,HighZoneName,OBJPROP_STYLE,STYLE_SOLID);
                  ObjectSetInteger(0,HighZoneName,OBJPROP_SELECTABLE,true);
                  ObjectSetInteger(0,HighZoneName,OBJPROP_FILL,true); 
                  ObjectSetInteger(0,HighZoneName,OBJPROP_BACK,false); 
                  
                  string HighestTime = TimeToString(iTime(_Symbol,period,HighOne),TIME_DATE|TIME_MINUTES);
                  Message  += "Highest Bar Date- " + HighestTime + " \n";
               }
            else if(!ObjectCreate(HighZoneName,OBJ_RECTANGLE,0,HZTime,HZPrice1,Time[0],HZPrice2))
               {
                  string errorcomment    = "UNABLE TO DRAW HIGH ZONE on " + _Symbol;
                  Print(errorcomment);
                  return;
               }      
         }
      if(LowOne > 0 && LowTwo > 0 && LowThree > 0 && ObjectFind(0,LowZoneName) < 0)
         {
            double LowPrice1    = iLow(_Symbol,period,LowTwo);
            double LLastPrice1   = iClose(_Symbol,period,LowTwo);
            double LowPrice2    = iLow(_Symbol,period,LowThree);
            double LLastPrice2   = iClose(_Symbol,period,LowThree);
            double LowPrice3    = LowPrice1;
            double LLastPrice3   = LLastPrice1;
            
            if(LLastPrice2 > LLastPrice1)LLastPrice3 = LLastPrice2;
            if(LowPrice2 < LowPrice1)LowPrice3 = LowPrice2;
            if(LLastPrice3 > LZPrice1)LZPrice1 = LLastPrice3;
            if(LowPrice3 < LZPrice2)LZPrice2 = LowPrice3;
            
            LZTime      = iTime(_Symbol,period,LowThree);
            
            if(ObjectCreate(LowZoneName,OBJ_RECTANGLE,0,LZTime,LZPrice1,Time[0],LZPrice2))
               {
                  ObjectSetInteger(0,LowZoneName,OBJPROP_COLOR,Paint);
                  ObjectSetInteger(0,LowZoneName,OBJPROP_STYLE,STYLE_SOLID);
                  ObjectSetInteger(0,LowZoneName,OBJPROP_SELECTABLE,true);
                  ObjectSetInteger(0,LowZoneName,OBJPROP_FILL,true); 
                  ObjectSetInteger(0,LowZoneName,OBJPROP_BACK,false); 
                  
                  string LowestTime = TimeToString(iTime(_Symbol,period,LowOne),TIME_DATE|TIME_MINUTES);
                  Message  += "Lowest Bar Date- " + LowestTime + " \n";
               }
            else if(!ObjectCreate(LowZoneName,OBJ_RECTANGLE,0,LZTime,LZPrice1,Time[0],LZPrice2))
               {
                  string errorcomment1    = "UNABLE TO DRAW LOW ZONE on " + _Symbol;
                  Print(errorcomment1);
                  return;
               }   
         }
   }

//+------------------------------------------------------------------+
void StrategyThreeBreakoutCheck()
   {
      if(!ArrayFilled || TotalObjects <= 0) return;
      
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string name             = ObjectsName[obj];
            bool        Action           = ObjectAction[obj];
            ENUM_OBJECT Type             = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            bool        Shapes           = Type == OBJ_RECTANGLE || Type == OBJ_TREND || Action;
            if(!Shapes)continue;
            
            string EngulfyingBar    = EngulfyingType(period_5);
            double price_1          = ObjectPrice1[obj];
            double price_2          = ObjectPrice2[obj];
            double price_3          = ObjectGetValueByTime(0,name,Time[0]);
            string Status           = ObjectStatus[obj];
            double ask              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double bid              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            double close            = NormalizeDouble(iClose(_Symbol,period_5,1),_Digits);
            double high             = NormalizeDouble(iHigh(_Symbol,period_5,1),_Digits);
            double low              = NormalizeDouble(iLow(_Symbol,period_5,1),_Digits);
            color  ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool   StrategyColours3 = ObjectPaint == HighColour_3 || ObjectPaint == LowColour_3;
            bool   BuyTrend         = CurrentTrend == BUY_TREND || CurrentTrend == NO_TREND;
            bool   SellTrend        = CurrentTrend == SELL_TREND || CurrentTrend == NO_TREND; 
            
            if(!StrategyColours3)continue;
            
            if(StrategyColours3 && !HLTradeSignal_3 && ObjectStatus[obj] == Filled)
               {
                  if(ObjectPaint == HighColour_3 && high > price_2 && close < price_2)
                     {
                        HLConfirmTime_3      = true;
                        HLBreakoutType_3     = ClosedBelowHigh;
                        HLTradeSignal_3      = true;
                        ObjectAction[obj]    = true;
                        return;
                     }
                  else if(ObjectPaint == LowColour_3 && low < price_1 && close > price_1)
                     {
                        HLConfirmTime_3      = true;
                        HLBreakoutType_3     = ClosedAboveLow;
                        HLTradeSignal_3      = true;
                        ObjectAction[obj]    = true;
                        return;
                     }
               }
            else if(StrategyColours3 && !HLTradeSignal_3 && ObjectStatus[obj] == Traded)
               {
                  if(ObjectPaint == HighColour_3 && high > price_2 && close < price_2)
                     {
                        HLConfirmTime_3      = true;
                        HLBreakoutType_3     = ClosedBelowHigh;
                        HLTradeSignal_3      = true;
                        ObjectStatus[obj]    = Breakout;
                        ObjectAction[obj]    = true;
                        return;
                     }
                  else if(ObjectPaint == LowColour_3 && low < price_1 && close > price_1)
                     {
                        HLConfirmTime_3      = true;
                        HLBreakoutType_3     = ClosedAboveLow;
                        HLTradeSignal_3      = true;
                        ObjectStatus[obj]    = Breakout;
                        ObjectAction[obj]    = true;
                        return;
                     }
               }
         }
   }

//+------------------------------------------------------------------+
void StrategyThreeConfirmationCheck()
   {
      for(int obj = 0; obj < ObjectsTotal(0,0,-1); obj++)
         {
            string name             = ObjectsName[obj];
            bool        Action           = ObjectAction[obj];
            ENUM_OBJECT Type             = (ENUM_OBJECT)ObjectGetInteger(0,name,OBJPROP_TYPE);
            bool        Shapes           = Type == OBJ_RECTANGLE || Type == OBJ_TREND || !Action;
            if(!Shapes)continue;
            
            string EngulfyingBar    = EngulfyingType(period_5);
            string Status           = ObjectStatus[obj];
            double ask              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
            double bid              = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
            double price_1          = ObjectPrice1[obj];
            double price_2          = ObjectPrice2[obj];
            double price_3          = ObjectGetValueByTime(0,name,Time[0]);
            double close            = NormalizeDouble(iClose(_Symbol,period_5,1),_Digits);
            double high             = NormalizeDouble(iHigh(_Symbol,period_5,1),_Digits);
            double low              = NormalizeDouble(iLow(_Symbol,period_5,1),_Digits);
            color  ObjectPaint      = (color)ObjectGetInteger(0,name,OBJPROP_COLOR);
            bool   MainZonesColours = ObjectPaint == ResistanceColour || ObjectPaint == SupportColour;
            bool   DTZonesColours   = ObjectPaint == DTTopColour || ObjectPaint == DTBottomColour;
            bool   TrendColours     = ObjectPaint == UpperTrendColour || ObjectPaint == LowerTrendColour;
            bool   StrategyColours3 = ObjectPaint == HighColour_3 || ObjectPaint == LowColour_3;
            bool   BuyTrend_1       = MovingAverageSignal(BUY_TREND,period_5);
            bool   SellTrend_1      = MovingAverageSignal(SELL_TREND,period_5); 
            bool   AskMiddleZone    = ask < price_1 && ask > price_2;
            bool   BidMiddleZone    = bid < price_1 && bid > price_2;
            
            if(MainZonesColours || DTZonesColours || TrendColours || AskMiddleZone || BidMiddleZone)continue;
            
            if(StrategyColours3)
               {
                  if(!HLConfirmTime_3)continue;
                  
                  if(HLBreakoutType_3 == ClosedAboveLow && Status == Filled)
                     {
                        if(UseMA == YES)
                           {
                              if(BuyTrend_1 && EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Above Low");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Above Low");
                                 }
                           }
                     }
                  else if(HLBreakoutType_3 == ClosedAboveLow && Status == Breakout)
                     {
                        if(UseMA == YES)
                           {
                              if(BuyTrend_1 && EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Above Low Retest Trade");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BullEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    BUY(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Above Low Retest Trade");
                                 }
                           }
                     }
                  else if(HLBreakoutType_3 == ClosedBelowHigh && Status == Filled)
                     {
                        if(UseMA == YES)
                           {
                              if(SellTrend_1 && EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Below High");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Below High");
                                 }
                           }
                     }
                  else if(HLBreakoutType_3 == ClosedBelowHigh && Status == Breakout)
                     {
                        if(UseMA == YES)
                           {
                              if(SellTrend_1 && EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Below High Retest Trade");
                                 }
                           }
                        else if(UseMA== NO)
                           {
                              if(EngulfyingBar == BearEngulfying)
                                 {
                                    HLConfirmTime_3     = false;
                                    HLTradeSignal_3     = false;
                                    ObjectStatus[obj]   = Traded;
                                    ObjectAction[obj]   = false;
                                    SELL(STRATEGY_THREE,MagicStrategy_3,period_5,"STRATEGY 3 Closed Below High Retest Trade");
                                 }
                           }
                     }
               }
         }
   }

//+------------------------------------------------------------------+
void BUY(STRATEGY_VERSION Version, int Magic, ENUM_TIMEFRAMES period, string PrintMessage)
   {
      bool   ords = OpenSellTrades();
      if(ords)return;
      
      double ask  = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
      double sl   = StopLossPrice(Version,BuyTrades,period);
      double tp   = TakeProfitPrice(Version,BuyTrades);
      tp = NormalizeDouble(tp,_Digits);
      sl = NormalizeDouble(sl,_Digits);
      string ctp  = DoubleToString(tp,_Digits);
      string csl  = DoubleToString(sl,_Digits);
      
      int buys = OrderSend(Symbol(),OP_BUY,Lot(),ask,10,sl,tp,EA_Comment,Magic);
      if(buys < 0)
        {
           ErrCode = GetLastError();
           Print("Equal H/L FAIL Trade Buy, " + _Symbol + "- " + ErrorDescription(ErrCode) + " TP: " + ctp + " SL: " + csl);
           return;
        }
      else
        {
            Print(PrintMessage + " SUCCESS Trade Buy, " + _Symbol);
            return;
        } 
   }
   
//+------------------------------------------------------------------+
void SELL(STRATEGY_VERSION Version, int Magic, ENUM_TIMEFRAMES period, string PrintMessage)
   {
      bool   ords = OpenBuyTrades();
      if(ords)return;
      
      double bid  = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
      double sl   = StopLossPrice(Version,SellTrades,period);
      double tp   = TakeProfitPrice(Version,SellTrades);
      tp = NormalizeDouble(tp,_Digits);
      sl = NormalizeDouble(sl,_Digits);
      string ctp  = DoubleToString(tp,_Digits);
      string csl  = DoubleToString(sl,_Digits);
      
      int sells = OrderSend(Symbol(),OP_SELL,Lot(),bid,10,sl,tp,EA_Comment,Magic);
      if(sells < 0)
        {
           ErrCode = GetLastError();
           Print("Equal H/L FAIL Trade Sell, " + _Symbol + "- " + ErrorDescription(ErrCode) + " TP: " + ctp + " SL: " + csl);
           return;
        }
      else
        {
            Print(PrintMessage + " SUCCESS Trade Sell, " + _Symbol);
            return;
        } 
   }

//+------------------------------------------------------------------+
double Lot()
   {
      double minLot  = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
      double maxLot  = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
      double LotStep = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
      double Vol     = FirstLot;
      
      if(OrdersTotal() == 1)
         {
            double Vol2 = FirstLot * 2;
            Vol2        = MathMin(MathMax(Vol2,minLot),maxLot);
            return Vol2;
         }
      
      else if(OrdersTotal() > 1)
         {
            datetime time   = NULL;
            double   Vol3   = 0;
            for(int i = OrdersTotal() - 1; i >= 0; i--)
               {
                  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)break;
                  if(OrderSymbol() != _Symbol)continue;
                  if(OrderOpenTime() > time)
                     {
                        Vol3   = OrderLots() + 0.1;
                        time   = OrderOpenTime();
                     }
               }
            Vol3 = MathMin(MathMax(Vol3,minLot),maxLot);
            return Vol3;
         }
      Vol = MathMin(MathMax(Vol,minLot),maxLot);
      
      return Vol;
   }

//+------------------------------------------------------------------+
void CLOSEALL(int Magic)
   {
      for(int i = OrdersTotal() - 1; i >= 0; i--)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
            if(OrderSymbol() != _Symbol)continue;
            if(OrderMagicNumber() != Magic)continue;
            if(OrderType() == OP_BUY)
               {
                  if(!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),10,clrWhite))
                     {
                       ErrCode = GetLastError();
                       Print("Unable to close Buy order due to ",ErrorDescription(ErrCode));
                     }
               }
            if(OrderType() == OP_SELL)
               {
                  if(!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),10,clrWhite))
                     {
                       ErrCode = GetLastError();
                       Print("Unable to close Sell order due to ",ErrorDescription(ErrCode));
                     }
               }
         }
   }

//+------------------------------------------------------------------+
bool NEWBAR(ENUM_TIMEFRAMES period)
   {
      datetime time_period    = iTime(Symbol(),period,0);
      
      if((time_period != BarTime1) && (period == period_1))
         {
            BarTime1  = time_period;
            return true;
         }
      
      if((time_period != BarTime2) && (period == period_3))
         {
            BarTime2  = time_period;
            return true;
         }
      if((time_period != BarTime3) && (period == period_4))
         {
            BarTime3  = time_period;
            
            if(ObjectFind(0,HighNameStrategy_2) >= 0 || ObjectFind(0,LowNameStrategy_2) >= 0)
               {
                  ObjectDelete(0,HighNameStrategy_2);
                  ObjectDelete(0,LowNameStrategy_2);
                  
                  Print("STRATEGY TWO Lines Deleted");
                  HLConfirmTime_2      = false;
                  HLBreakoutType_2     = Nothing;
                  HLTradeSignal_2      = false;
               }
            
            if(ObjectFind(0,HighNameStrategy_3) >= 0 || ObjectFind(0,LowNameStrategy_3) >= 0)
               {
                  if(ObjectFind(0,HighNameStrategy_3) >= 0)ObjectDelete(0,HighNameStrategy_3);
                  if(ObjectFind(0,LowNameStrategy_3) >= 0)ObjectDelete(0,LowNameStrategy_3);
                  
                  Print("STRATEGY THREE Lines Deleted");
                  HLConfirmTime_3      = false;
                  HLBreakoutType_3     = Nothing;
                  HLTradeSignal_3      = false;
               }
            return true;
         }
      
      if((time_period != BarTime4) && (period == period_5))
         {
            BarTime4  = time_period;
            return true;
         }
      if((time_period != BarTime5) && (period == RefreshDataTime))
         {
            BarTime5  = time_period;
            return true;
         }
      
      return false;
   }

//+------------------------------------------------------------------+
string PeriodString(ENUM_TIMEFRAMES period)
   {
      string   orders         = "";
      
      if(period == PERIOD_M1)orders       = "Period M1 ";
      else if(period == PERIOD_M5)orders  = "Period M5 ";
      else if(period == PERIOD_M15)orders = "Period M15 ";
      else if(period == PERIOD_M30)orders = "Period M30 ";
      else if(period == PERIOD_H1)orders  = "Period H1 ";
      else if(period == PERIOD_H4)orders  = "Period H4 ";
      else if(period == PERIOD_D1)orders  = "Period D1 ";
      else if(period == PERIOD_W1)orders  = "Period W1 ";
      else if(period == PERIOD_MN1)orders = "Period MN1 ";
      
      return orders;
   }

//+------------------------------------------------------------------+

